# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from zuora_sdk.models.create_payment_request import CreatePaymentRequest

class TestCreatePaymentRequest(unittest.TestCase):
    """CreatePaymentRequest unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional) -> CreatePaymentRequest:
        """Test CreatePaymentRequest
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `CreatePaymentRequest`
        """
        model = CreatePaymentRequest()
        if include_optional:
            return CreatePaymentRequest(
                account_id = '',
                account_number = '',
                amount = 1.337,
                auth_transaction_id = '',
                comment = '',
                currency = '',
                custom_rates = [
                    zuora_sdk.models.custom_rates.customRates(
                        currency = '', 
                        custom_fx_rate = 1, 
                        rate_date = '', )
                    ],
                debit_memos = [
                    zuora_sdk.models.debit_memos.debitMemos(
                        amount = 1.337, 
                        debit_memo_id = '', 
                        debit_memo_number = '', 
                        items = [
                            zuora_sdk.models.items.items(
                                amount = 1.337, 
                                debit_memo_item_id = '', 
                                tax_item_id = '', )
                            ], )
                    ],
                effective_date = '',
                finance_information = zuora_sdk.models.payment_request_finance_information.PaymentRequest_financeInformation(
                    bank_account_accounting_code = '', 
                    transferred_to_accounting = 'Processing', 
                    unapplied_payment_accounting_code = '', ),
                gateway_id = '',
                payment_gateway_number = '',
                gateway_options = zuora_sdk.models.gateway_options.GatewayOptions(
                    key = '', 
                    value = '', ),
                gateway_order_id = '',
                invoices = [
                    zuora_sdk.models.invoices.invoices(
                        amount = 1.337, 
                        invoice_id = '', 
                        invoice_number = '', 
                        items = [
                            zuora_sdk.models.items.items(
                                amount = 1.337, 
                                invoice_item_id = '', 
                                tax_item_id = '', )
                            ], )
                    ],
                mit_transaction_source = 'C_Unscheduled',
                payment_method_id = '',
                payment_method_type = '',
                payment_option = [
                    zuora_sdk.models.payment_option.paymentOption(
                        detail = zuora_sdk.models.payment_schedule_payment_option_fields_detail.PaymentSchedulePaymentOptionFieldsDetail(
                            key = '', 
                            value = '', ), 
                        type = '', )
                    ],
                payment_schedule_key = '',
                prepayment = True,
                reference_id = '',
                soft_descriptor = '',
                soft_descriptor_phone = '',
                standalone = True,
                type = 'External'
            )
        else:
            return CreatePaymentRequest(
                amount = 1.337,
                currency = '',
                type = 'External',
        )
        """

    def testCreatePaymentRequest(self):
        """Test CreatePaymentRequest"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
