# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AccountSummaryDefaultPaymentMethod(BaseModel):
    """
    
    """ # noqa: E501
    credit_card_expiration_month: Optional[StrictStr] = Field(default=None, description="Two-digit numeric card expiration month as `mm`. ", alias="creditCardExpirationMonth")
    credit_card_expiration_year: Optional[StrictStr] = Field(default=None, description="Four-digit card expiration year as `yyyy`. ", alias="creditCardExpirationYear")
    credit_card_number: Optional[StrictStr] = Field(default=None, description="Credit card number, 16 characters or less, displayed in masked format (e.g., ************1234). ", alias="creditCardNumber")
    credit_card_type: Optional[StrictStr] = Field(default=None, description="The type of the credit card.  Possible values  include `Visa`, `MasterCard`, `AmericanExpress`, `Discover`, `JCB`, and `Diners`. For more information about credit card types supported by different payment gateways, see [Supported Payment Methods](https://knowledgecenter.zuora.com/Zuora_Central/Billing_and_Payments/L_Payment_Methods/Supported_Payment_Methods). ", alias="creditCardType")
    id: Optional[StrictStr] = Field(default=None, description="ID of the default payment method associated with this account. ")
    payment_method_type: Optional[StrictStr] = Field(default=None, alias="paymentMethodType")
    __properties: ClassVar[List[str]] = ["creditCardExpirationMonth", "creditCardExpirationYear", "creditCardNumber", "creditCardType", "id", "paymentMethodType"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AccountSummaryDefaultPaymentMethod from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AccountSummaryDefaultPaymentMethod from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "creditCardExpirationMonth": obj.get("creditCardExpirationMonth"),
            "creditCardExpirationYear": obj.get("creditCardExpirationYear"),
            "creditCardNumber": obj.get("creditCardNumber"),
            "creditCardType": obj.get("creditCardType"),
            "id": obj.get("id"),
            "paymentMethodType": obj.get("paymentMethodType")
        })
        return _obj


