# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from decimal import Decimal
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class BillingAdjustment(BaseModel):
    """
    BillingAdjustment
    """ # noqa: E501
    adjustment_id: Optional[StrictStr] = Field(default=None, description="The system generated Adjustment Id. ", alias="adjustmentId")
    adjustment_number: Optional[StrictStr] = Field(default=None, description="The system generated Adjustment Number. ", alias="adjustmentNumber")
    amount: Optional[Decimal] = Field(default=None, description="The amount of the adjustment. ")
    billing_date: Optional[date] = Field(default=None, description="The billing date is same as the delivery date of the adjustment, in `yyyy-mm-dd` format. ", alias="billingDate")
    charge_number: Optional[StrictStr] = Field(default=None, description="The charge number in the subscription for which the adjustment is created. ", alias="chargeNumber")
    credit_memo_number: Optional[StrictStr] = Field(default=None, description="The Credit Memo generated for the adjustment. ", alias="creditMemoNumber")
    deferred_revenue_accounting_code: Optional[StrictStr] = Field(default=None, description="The accounting code for the deferred revenue, such as Monthly Recurring Liability. ", alias="deferredRevenueAccountingCode")
    delivery_date: Optional[date] = Field(default=None, description="The adjustment date, in `yyyy-mm-dd` format. ", alias="deliveryDate")
    delivery_day: Optional[StrictStr] = Field(default=None, description="The adjustment day of the week. ", alias="deliveryDay")
    eligible: Optional[StrictBool] = Field(default=None, description="The eligible flag is set as true for a successfully created adjustment. ")
    reason: Optional[StrictStr] = Field(default=None, description="The reason for the adjustment. ")
    recognized_revenue_accounting_code: Optional[StrictStr] = Field(default=None, description="The accounting code for the recognized revenue, such as Monthly Recurring Charges or Overage Charges. ", alias="recognizedRevenueAccountingCode")
    revenue_recognition_rule_name: Optional[StrictStr] = Field(default=None, description="The name of the revenue recognition rule governing the revenue schedule. ", alias="revenueRecognitionRuleName")
    status: Optional[StrictStr] = Field(default=None, description="The status of the adjustment will be `Billed` or `Cancelled`. ")
    subscription_number: Optional[StrictStr] = Field(default=None, description="The subscription number for which the adjustment is created. ", alias="subscriptionNumber")
    __properties: ClassVar[List[str]] = ["adjustmentId", "adjustmentNumber", "amount", "billingDate", "chargeNumber", "creditMemoNumber", "deferredRevenueAccountingCode", "deliveryDate", "deliveryDay", "eligible", "reason", "recognizedRevenueAccountingCode", "revenueRecognitionRuleName", "status", "subscriptionNumber"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BillingAdjustment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BillingAdjustment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "adjustmentId": obj.get("adjustmentId"),
            "adjustmentNumber": obj.get("adjustmentNumber"),
            "amount": obj.get("amount"),
            "billingDate": obj.get("billingDate"),
            "chargeNumber": obj.get("chargeNumber"),
            "creditMemoNumber": obj.get("creditMemoNumber"),
            "deferredRevenueAccountingCode": obj.get("deferredRevenueAccountingCode"),
            "deliveryDate": obj.get("deliveryDate"),
            "deliveryDay": obj.get("deliveryDay"),
            "eligible": obj.get("eligible"),
            "reason": obj.get("reason"),
            "recognizedRevenueAccountingCode": obj.get("recognizedRevenueAccountingCode"),
            "revenueRecognitionRuleName": obj.get("revenueRecognitionRuleName"),
            "status": obj.get("status"),
            "subscriptionNumber": obj.get("subscriptionNumber")
        })
        return _obj


