# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class ChargeMetrics(BaseModel):
    """
    Container for charge metrics. 
    """ # noqa: E501
    dmrr: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Change in monthly recurring revenue. ")
    dtcv: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Change in total contract value. ")
    mrr: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Monthly recurring revenue. ")
    number: Optional[StrictStr] = Field(default=None, description="The charge number of the subscription. Only available for update subscription. ")
    origin_rate_plan_id: Optional[StrictStr] = Field(default=None, description="The origin rate plan ID. Only available for update subscription. ", alias="originRatePlanId")
    original_id: Optional[StrictStr] = Field(default=None, description="The original rate plan charge ID. Only available for update subscription. ", alias="originalId")
    product_rate_plan_charge_id: Optional[StrictStr] = Field(default=None, description="The product rate plan charge ID. ", alias="productRatePlanChargeId")
    product_rate_plan_id: Optional[StrictStr] = Field(default=None, description="The product rate plan ID. ", alias="productRatePlanId")
    tcv: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Total contract value. ")
    __properties: ClassVar[List[str]] = ["dmrr", "dtcv", "mrr", "number", "originRatePlanId", "originalId", "productRatePlanChargeId", "productRatePlanId", "tcv"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChargeMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChargeMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dmrr": obj.get("dmrr"),
            "dtcv": obj.get("dtcv"),
            "mrr": obj.get("mrr"),
            "number": obj.get("number"),
            "originRatePlanId": obj.get("originRatePlanId"),
            "originalId": obj.get("originalId"),
            "productRatePlanChargeId": obj.get("productRatePlanChargeId"),
            "productRatePlanId": obj.get("productRatePlanId"),
            "tcv": obj.get("tcv")
        })
        return _obj


