# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class ChargeTier(BaseModel):
    """
    ChargeTier
    """ # noqa: E501
    ending_unit: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Limit on the number of units for which the tier is effective. ", alias="endingUnit")
    price: Union[StrictFloat, StrictInt] = Field(description="Price or per-unit price of the tier, depending on the value of the `priceFormat` field. ")
    price_format: StrictStr = Field(alias="priceFormat")
    starting_unit: Union[StrictFloat, StrictInt] = Field(description="Number of units at which the tier becomes effective. ", alias="startingUnit")
    tier: Annotated[int, Field(strict=True, ge=1)] = Field(description="Index of the tier in the charge. ")
    __properties: ClassVar[List[str]] = ["endingUnit", "price", "priceFormat", "startingUnit", "tier"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChargeTier from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChargeTier from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "endingUnit": obj.get("endingUnit"),
            "price": obj.get("price"),
            "priceFormat": obj.get("priceFormat"),
            "startingUnit": obj.get("startingUnit"),
            "tier": obj.get("tier")
        })
        return _obj


