# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ConfigurationTemplateContent(BaseModel):
    """
    It contains information about template schemas with segregation keys.
    """ # noqa: E501
    component_type: Optional[StrictStr] = Field(default=None, description="Type of Component.", alias="componentType")
    error: Optional[StrictStr] = Field(default=None, description="Error Information.")
    id: Optional[StrictStr] = Field(default=None, description="Id of Each component.")
    key: Optional[StrictStr] = Field(default=None, description="Key value of fields inside component.")
    method: Optional[StrictStr] = Field(default=None, description="Http method which is used to retrieve the particular component.")
    payload: Optional[Dict[str, Any]] = Field(default=None, description="Json node object contains metadata.")
    result: Optional[StrictStr] = Field(default=None, description="Contains the response of details fetched regarding selected component.")
    segregation_key: Optional[StrictStr] = Field(default=None, description="Gives the difference between components and sub components.", alias="segregationKey")
    template_id: Optional[StrictStr] = Field(default=None, description="Id of the Template.", alias="templateId")
    url: Optional[StrictStr] = Field(default=None, description="Metadata is retrieved from this URL.")
    __properties: ClassVar[List[str]] = ["componentType", "error", "id", "key", "method", "payload", "result", "segregationKey", "templateId", "url"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ConfigurationTemplateContent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ConfigurationTemplateContent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "componentType": obj.get("componentType"),
            "error": obj.get("error"),
            "id": obj.get("id"),
            "key": obj.get("key"),
            "method": obj.get("method"),
            "payload": obj.get("payload"),
            "result": obj.get("result"),
            "segregationKey": obj.get("segregationKey"),
            "templateId": obj.get("templateId"),
            "url": obj.get("url")
        })
        return _obj


