# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from zuora_sdk.models.gateway_options import GatewayOptions
from typing import Optional, Set
from typing_extensions import Self

class CreateAuthorizationRequest(BaseModel):
    """
    CreateAuthorizationRequest
    """ # noqa: E501
    account_id: Optional[StrictStr] = Field(default=None, description="The ID of the customer account. Either `accountId` or `accountNumber` is required.", alias="accountId")
    account_number: Optional[StrictStr] = Field(default=None, description="The number of the customer account. Either `accountNumber` or `accountId` is required.", alias="accountNumber")
    amount: Union[StrictFloat, StrictInt] = Field(description="The amount of the trasaction.")
    gateway_options: Optional[GatewayOptions] = Field(default=None, alias="gatewayOptions")
    gateway_order_id: StrictStr = Field(description="The order ID for the specific gateway.  The specified order ID will be used in transaction authorization. If you specify an empty value for this field, Zuora will generate an ID and you will have to associate this ID with your order ID by yourself if needed. It is recommended to specify an ID for this field. ", alias="gatewayOrderId")
    mit_transaction_source: Optional[StrictStr] = Field(default=None, alias="mitTransactionSource")
    payment_gateway_id: Optional[StrictStr] = Field(default=None, description="The ID of the payment gateway instance.", alias="paymentGatewayId")
    soft_descriptor: Optional[StrictStr] = Field(default=None, description="A text, rendered on a cardholder’s statement, describing a particular product or service purchased by the cardholder.", alias="softDescriptor")
    soft_descriptor_phone: Optional[StrictStr] = Field(default=None, description="The phone number that relates to the soft descriptor, usually the phone number of customer service.", alias="softDescriptorPhone")
    __properties: ClassVar[List[str]] = ["accountId", "accountNumber", "amount", "gatewayOptions", "gatewayOrderId", "mitTransactionSource", "paymentGatewayId", "softDescriptor", "softDescriptorPhone"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateAuthorizationRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of gateway_options
        if self.gateway_options:
            _dict['gatewayOptions'] = self.gateway_options.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateAuthorizationRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountId": obj.get("accountId"),
            "accountNumber": obj.get("accountNumber"),
            "amount": obj.get("amount"),
            "gatewayOptions": GatewayOptions.from_dict(obj["gatewayOptions"]) if obj.get("gatewayOptions") is not None else None,
            "gatewayOrderId": obj.get("gatewayOrderId"),
            "mitTransactionSource": obj.get("mitTransactionSource"),
            "paymentGatewayId": obj.get("paymentGatewayId"),
            "softDescriptor": obj.get("softDescriptor"),
            "softDescriptorPhone": obj.get("softDescriptorPhone")
        })
        return _obj


