# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CreateAuthorizationResponsePaymentGateway(BaseModel):
    """
    The response data returned from the gateway. This field is available only if the `success` field is `false` and the support for returning additional error information from the gateway is enabled. 
    """ # noqa: E501
    additional_info: Optional[Dict[str, Any]] = Field(default=None, description="The additional information returned from the gateway. The returned fields vary for gateways. Here is an example.  ``` \"additionalInfo\": {   \"ProcessorName\": \"MasterCard Saferpay Test\",   \"ProcessorResult\": \"51\",   \"ProcessorMessage\": \"Insufficient funds\",   \"ErrorName\": \"TRANSACTION_DECLINED\" } ``` ", alias="additionalInfo")
    gateway_response_code: Optional[StrictStr] = Field(default=None, description="The HTTP response code. ", alias="gatewayResponseCode")
    gateway_response_message: Optional[StrictStr] = Field(default=None, description="The error message returned from the gateway. ", alias="gatewayResponseMessage")
    gateway_type: Optional[StrictStr] = Field(default=None, description="The gateway type. ", alias="gatewayType")
    gateway_version: Optional[StrictStr] = Field(default=None, description="The gateway version. ", alias="gatewayVersion")
    __properties: ClassVar[List[str]] = ["additionalInfo", "gatewayResponseCode", "gatewayResponseMessage", "gatewayType", "gatewayVersion"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateAuthorizationResponsePaymentGateway from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateAuthorizationResponsePaymentGateway from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "additionalInfo": obj.get("additionalInfo"),
            "gatewayResponseCode": obj.get("gatewayResponseCode"),
            "gatewayResponseMessage": obj.get("gatewayResponseMessage"),
            "gatewayType": obj.get("gatewayType"),
            "gatewayVersion": obj.get("gatewayVersion")
        })
        return _obj


