# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CreateBillingPreviewInvoiceItem(BaseModel):
    """
    CreateBillingPreviewInvoiceItem
    """ # noqa: E501
    applied_to_item_id: Optional[StrictStr] = Field(default=None, description="The unique ID of the invoice item that the discount charge is applied to. ", alias="appliedToItemId")
    charge_amount: Optional[StrictStr] = Field(default=None, description="The amount of the charge. This amount doesn't include taxes regardless if the charge's tax mode is inclusive or exclusive. ", alias="chargeAmount")
    charge_date: Optional[StrictStr] = Field(default=None, description="The date when the invoice item was created. ", alias="chargeDate")
    charge_description: Optional[StrictStr] = Field(default=None, description="Description of the charge. ", alias="chargeDescription")
    charge_id: Optional[StrictStr] = Field(default=None, description="Id of the charge. ", alias="chargeId")
    charge_name: Optional[StrictStr] = Field(default=None, description="Name of the charge. ", alias="chargeName")
    charge_number: Optional[StrictStr] = Field(default=None, description="Number of the charge. ", alias="chargeNumber")
    charge_type: Optional[StrictStr] = Field(default=None, description="The type of charge.   Possible values are `OneTime`, `Recurring`, and `Usage`. ", alias="chargeType")
    id: Optional[StrictStr] = Field(default=None, description="Invoice item ID. ")
    number_of_deliveries: Optional[StrictStr] = Field(default=None, description="The number of delivery for charge.  **Note**: This field is available only if you have the Delivery Pricing feature enabled. ", alias="numberOfDeliveries")
    processing_type: Optional[StrictStr] = Field(default=None, description="Identifies the kind of charge.   Possible values: * charge * discount * prepayment * tax ", alias="processingType")
    product_name: Optional[StrictStr] = Field(default=None, description="Name of the product associated with this item. ", alias="productName")
    quantity: Optional[StrictStr] = Field(default=None, description="Quantity of this item, in the configured unit of measure for the charge. ")
    service_end_date: Optional[date] = Field(default=None, description="End date of the service period for this item, i.e., the last day of the service period, in `yyyy-mm-dd` format. ", alias="serviceEndDate")
    service_start_date: Optional[date] = Field(default=None, description="Start date of the service period for this item, in `yyyy-mm-dd` format. If the charge is a one-time fee, this is the date of that charge. ", alias="serviceStartDate")
    subscription_id: Optional[StrictStr] = Field(default=None, description="ID of the subscription associated with this item. ", alias="subscriptionId")
    subscription_name: Optional[StrictStr] = Field(default=None, description="Name of the subscription associated with this item. ", alias="subscriptionName")
    subscription_number: Optional[StrictStr] = Field(default=None, description="Number of the subscription associated with this item. ", alias="subscriptionNumber")
    tax_amount: Optional[StrictStr] = Field(default=None, description="If you use [Zuora Tax](https://knowledgecenter.zuora.com/Billing/Taxes/A_Zuora_Tax) and the product rate plan charge associated with the invoice item is of [tax inclusive mode](https://knowledgecenter.zuora.com/Billing/Taxes/A_Zuora_Tax/D_Associate_tax_codes_with_product_charges_and_set_the_tax_mode), the value of this field is the amount of tax applied to the charge. Otherwise, the value of this field is `0`.  ", alias="taxAmount")
    unit_of_measure: Optional[StrictStr] = Field(default=None, description="Unit used to measure consumption. ", alias="unitOfMeasure")
    __properties: ClassVar[List[str]] = ["appliedToItemId", "chargeAmount", "chargeDate", "chargeDescription", "chargeId", "chargeName", "chargeNumber", "chargeType", "id", "numberOfDeliveries", "processingType", "productName", "quantity", "serviceEndDate", "serviceStartDate", "subscriptionId", "subscriptionName", "subscriptionNumber", "taxAmount", "unitOfMeasure"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateBillingPreviewInvoiceItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateBillingPreviewInvoiceItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "appliedToItemId": obj.get("appliedToItemId"),
            "chargeAmount": obj.get("chargeAmount"),
            "chargeDate": obj.get("chargeDate"),
            "chargeDescription": obj.get("chargeDescription"),
            "chargeId": obj.get("chargeId"),
            "chargeName": obj.get("chargeName"),
            "chargeNumber": obj.get("chargeNumber"),
            "chargeType": obj.get("chargeType"),
            "id": obj.get("id"),
            "numberOfDeliveries": obj.get("numberOfDeliveries"),
            "processingType": obj.get("processingType"),
            "productName": obj.get("productName"),
            "quantity": obj.get("quantity"),
            "serviceEndDate": obj.get("serviceEndDate"),
            "serviceStartDate": obj.get("serviceStartDate"),
            "subscriptionId": obj.get("subscriptionId"),
            "subscriptionName": obj.get("subscriptionName"),
            "subscriptionNumber": obj.get("subscriptionNumber"),
            "taxAmount": obj.get("taxAmount"),
            "unitOfMeasure": obj.get("unitOfMeasure")
        })
        return _obj


