# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.create_fulfillment_item_response import CreateFulfillmentItemResponse
from typing import Optional, Set
from typing_extensions import Self

class CreateFulfillmentResponse(BaseModel):
    """
    CreateFulfillmentResponse
    """ # noqa: E501
    fulfillment_items: Optional[List[CreateFulfillmentItemResponse]] = Field(default=None, alias="fulfillmentItems")
    fulfillment_number: Optional[StrictStr] = Field(default=None, description="The sytem generated number for the Fulfillment. ", alias="fulfillmentNumber")
    id: Optional[StrictStr] = Field(default=None, description="The sytem generated Id. ")
    __properties: ClassVar[List[str]] = ["fulfillmentItems", "fulfillmentNumber", "id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateFulfillmentResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in fulfillment_items (list)
        _items = []
        if self.fulfillment_items:
            for _item in self.fulfillment_items:
                if _item:
                    _items.append(_item.to_dict())
            _dict['fulfillmentItems'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateFulfillmentResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fulfillmentItems": [CreateFulfillmentItemResponse.from_dict(_item) for _item in obj["fulfillmentItems"]] if obj.get("fulfillmentItems") is not None else None,
            "fulfillmentNumber": obj.get("fulfillmentNumber"),
            "id": obj.get("id")
        })
        return _obj


