# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.create_invoice_collect_credit_memos import CreateInvoiceCollectCreditMemos
from zuora_sdk.models.create_invoice_collect_invoices import CreateInvoiceCollectInvoices
from typing import Optional, Set
from typing_extensions import Self

class CreateInvoiceCollectResponse(BaseModel):
    """
    CreateInvoiceCollectResponse
    """ # noqa: E501
    amount_collected: Optional[StrictStr] = Field(default=None, description="Payment amount applied. ", alias="amountCollected")
    credit_memos: Optional[List[CreateInvoiceCollectCreditMemos]] = Field(default=None, description="Information on one or more credit memos associated with this operation. ", alias="creditMemos")
    invoices: Optional[List[CreateInvoiceCollectInvoices]] = Field(default=None, description="Information on one or more invoices associated with this operation. ")
    payment_id: Optional[StrictStr] = Field(default=None, description="Payment ID. ", alias="paymentId")
    success: Optional[StrictBool] = Field(default=None, description="Returns `true` if the request was processed successfully. ")
    __properties: ClassVar[List[str]] = ["amountCollected", "creditMemos", "invoices", "paymentId", "success"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateInvoiceCollectResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in credit_memos (list)
        _items = []
        if self.credit_memos:
            for _item in self.credit_memos:
                if _item:
                    _items.append(_item.to_dict())
            _dict['creditMemos'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in invoices (list)
        _items = []
        if self.invoices:
            for _item in self.invoices:
                if _item:
                    _items.append(_item.to_dict())
            _dict['invoices'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateInvoiceCollectResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "amountCollected": obj.get("amountCollected"),
            "creditMemos": [CreateInvoiceCollectCreditMemos.from_dict(_item) for _item in obj["creditMemos"]] if obj.get("creditMemos") is not None else None,
            "invoices": [CreateInvoiceCollectInvoices.from_dict(_item) for _item in obj["invoices"]] if obj.get("invoices") is not None else None,
            "paymentId": obj.get("paymentId"),
            "success": obj.get("success")
        })
        return _obj


