# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.time_sliced_metrics import TimeSlicedMetrics
from zuora_sdk.models.time_sliced_net_metrics import TimeSlicedNetMetrics
from zuora_sdk.models.time_sliced_tcb_net_metrics import TimeSlicedTcbNetMetrics
from typing import Optional, Set
from typing_extensions import Self

class CreateOrderResponseOrderMetric(BaseModel):
    """
    The order metrics in create order response.
    """ # noqa: E501
    charge_number: Optional[StrictStr] = Field(default=None, alias="chargeNumber")
    mrr: Optional[List[TimeSlicedNetMetrics]] = None
    quantity: Optional[List[TimeSlicedMetrics]] = None
    tcb: Optional[List[TimeSlicedTcbNetMetrics]] = Field(default=None, description="Total contracted billing which is the forecast value for the total invoice amount.")
    tcv: Optional[List[TimeSlicedNetMetrics]] = Field(default=None, description="Total contracted value.")
    __properties: ClassVar[List[str]] = ["chargeNumber", "mrr", "quantity", "tcb", "tcv"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateOrderResponseOrderMetric from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in mrr (list)
        _items = []
        if self.mrr:
            for _item in self.mrr:
                if _item:
                    _items.append(_item.to_dict())
            _dict['mrr'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in quantity (list)
        _items = []
        if self.quantity:
            for _item in self.quantity:
                if _item:
                    _items.append(_item.to_dict())
            _dict['quantity'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in tcb (list)
        _items = []
        if self.tcb:
            for _item in self.tcb:
                if _item:
                    _items.append(_item.to_dict())
            _dict['tcb'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in tcv (list)
        _items = []
        if self.tcv:
            for _item in self.tcv:
                if _item:
                    _items.append(_item.to_dict())
            _dict['tcv'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateOrderResponseOrderMetric from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "chargeNumber": obj.get("chargeNumber"),
            "mrr": [TimeSlicedNetMetrics.from_dict(_item) for _item in obj["mrr"]] if obj.get("mrr") is not None else None,
            "quantity": [TimeSlicedMetrics.from_dict(_item) for _item in obj["quantity"]] if obj.get("quantity") is not None else None,
            "tcb": [TimeSlicedTcbNetMetrics.from_dict(_item) for _item in obj["tcb"]] if obj.get("tcb") is not None else None,
            "tcv": [TimeSlicedNetMetrics.from_dict(_item) for _item in obj["tcv"]] if obj.get("tcv") is not None else None
        })
        return _obj


