# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.create_order_response_order_action import CreateOrderResponseOrderAction
from typing import Optional, Set
from typing_extensions import Self

class CreateOrderResponseSubscriptions(BaseModel):
    """
    CreateOrderResponseSubscriptions
    """ # noqa: E501
    status: Optional[StrictStr] = None
    subscription_id: Optional[StrictStr] = Field(default=None, description="Subscription ID of the subscription included in this order. This field is returned instead of the `subscriptionNumber` field if the `returnIds` query parameter is set to `true`.", alias="subscriptionId")
    subscription_number: Optional[StrictStr] = Field(default=None, description="Subscription number of the subscription included in this order.", alias="subscriptionNumber")
    subscription_owner_id: Optional[StrictStr] = Field(default=None, description="subscription owner account id of the subscription", alias="subscriptionOwnerId")
    subscription_owner_number: Optional[StrictStr] = Field(default=None, description="subscription owner account number of the subscription", alias="subscriptionOwnerNumber")
    order_actions: Optional[List[CreateOrderResponseOrderAction]] = Field(default=None, description="subscription order action metrics", alias="OrderActions")
    __properties: ClassVar[List[str]] = ["status", "subscriptionId", "subscriptionNumber", "subscriptionOwnerId", "subscriptionOwnerNumber", "OrderActions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateOrderResponseSubscriptions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in order_actions (list)
        _items = []
        if self.order_actions:
            for _item in self.order_actions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['OrderActions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateOrderResponseSubscriptions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "status": obj.get("status"),
            "subscriptionId": obj.get("subscriptionId"),
            "subscriptionNumber": obj.get("subscriptionNumber"),
            "subscriptionOwnerId": obj.get("subscriptionOwnerId"),
            "subscriptionOwnerNumber": obj.get("subscriptionOwnerNumber"),
            "OrderActions": [CreateOrderResponseOrderAction.from_dict(_item) for _item in obj["OrderActions"]] if obj.get("OrderActions") is not None else None
        })
        return _obj


