# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class CreatePaymentMethodBankTransferAccountHolderInfo(BaseModel):
    """
    This container field is required for the following bank transfer payment methods. The nested `accountHolderName` field is required.   - Direct Debit NZ (`Becsnz`)   - Single Euro Payments Area (`SEPA`)   - Direct Debit UK (`Bacs`)   - Denmark Direct Debit (`Betalingsservice`)   - Sweden Direct Debit (`Autogiro`)   - Canadian Pre-Authorized Debit (`PAD`) 
    """ # noqa: E501
    account_holder_name: Optional[Annotated[str, Field(strict=True, max_length=60)]] = Field(default=None, description="Required.  The full name of the bank account holder. ", alias="accountHolderName")
    address_line1: Optional[StrictStr] = Field(default=None, description="The first line of the address for the account holder.  This field is required for SEPA Direct Debit payment methods on Stripe v2 for [certain countries](https://stripe.com/docs/payments/sepa-debit/set-up-payment?platform=web#web-submit-payment-method). ", alias="addressLine1")
    address_line2: Optional[StrictStr] = Field(default=None, description="The second line of the address for the account holder.  ", alias="addressLine2")
    city: Optional[StrictStr] = Field(default=None, description="The city where the account holder stays.  It is recommended to provide the city and country information when creating a payment method. The information will be used to process payments. If the information is not provided during payment method creation, the city and country data will be missing during payment processing. ")
    country: Optional[StrictStr] = Field(default=None, description="The country where the account holder stays.  This field is required for SEPA payment methods on Stripe v2 for [certain countries](https://stripe.com/docs/payments/sepa-debit/set-up-payment?platform=web#web-submit-payment-method). ")
    email: Optional[StrictStr] = Field(default=None, description="The email address of the account holder. ")
    first_name: Optional[StrictStr] = Field(default=None, description="The first name of the account holder. ", alias="firstName")
    last_name: Optional[StrictStr] = Field(default=None, description="The last name of the account holder. ", alias="lastName")
    phone: Optional[StrictStr] = Field(default=None, description="The phone number of the account holder. ")
    state: Optional[StrictStr] = Field(default=None, description="The state where the account holder stays. ")
    zip_code: Optional[StrictStr] = Field(default=None, description="The zip code for the address of the account holder. ", alias="zipCode")
    __properties: ClassVar[List[str]] = ["accountHolderName", "addressLine1", "addressLine2", "city", "country", "email", "firstName", "lastName", "phone", "state", "zipCode"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreatePaymentMethodBankTransferAccountHolderInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreatePaymentMethodBankTransferAccountHolderInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountHolderName": obj.get("accountHolderName"),
            "addressLine1": obj.get("addressLine1"),
            "addressLine2": obj.get("addressLine2"),
            "city": obj.get("city"),
            "country": obj.get("country"),
            "email": obj.get("email"),
            "firstName": obj.get("firstName"),
            "lastName": obj.get("lastName"),
            "phone": obj.get("phone"),
            "state": obj.get("state"),
            "zipCode": obj.get("zipCode")
        })
        return _obj


