# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.create_payment_method_updater_batch_response_reasons import CreatePaymentMethodUpdaterBatchResponseReasons
from typing import Optional, Set
from typing_extensions import Self

class CreatePaymentMethodUpdaterBatchResponse(BaseModel):
    """
    CreatePaymentMethodUpdaterBatchResponse
    """ # noqa: E501
    process_id: Optional[StrictStr] = Field(default=None, description="The ID of the running process when the exception occurs. This field is available only if the `success` field is `false`. ", alias="processId")
    reasons: Optional[List[CreatePaymentMethodUpdaterBatchResponseReasons]] = Field(default=None, description="The container of the error code and message. This field is available only if the `success` field is `false`. ")
    request_id: Optional[StrictStr] = Field(default=None, description="The ID of the request. This field is available only if the `success` field is `false` ", alias="requestId")
    success: Optional[StrictBool] = Field(default=None, description="Indicates whether the request to create a PMU batch is sent successfully. ")
    __properties: ClassVar[List[str]] = ["processId", "reasons", "requestId", "success"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreatePaymentMethodUpdaterBatchResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in reasons (list)
        _items = []
        if self.reasons:
            for _item in self.reasons:
                if _item:
                    _items.append(_item.to_dict())
            _dict['reasons'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreatePaymentMethodUpdaterBatchResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "processId": obj.get("processId"),
            "reasons": [CreatePaymentMethodUpdaterBatchResponseReasons.from_dict(_item) for _item in obj["reasons"]] if obj.get("reasons") is not None else None,
            "requestId": obj.get("requestId"),
            "success": obj.get("success")
        })
        return _obj


