# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class CreateStoredCredentialProfileRequest(BaseModel):
    """
    CreateStoredCredentialProfileRequest
    """ # noqa: E501
    action: Optional[StrictStr] = None
    agreed_on: Optional[date] = Field(default=None, description="The date on which the profile is agreed. The date format is `yyyy-mm-dd`. ", alias="agreedOn")
    auth_gateway: Optional[StrictStr] = Field(default=None, description="Specifies the ID of the payment gateway that Zuora will use when activating the stored credential profile. ", alias="authGateway")
    card_security_code: Optional[StrictStr] = Field(default=None, description="The security code of the credit card. ", alias="cardSecurityCode")
    consent_agreement_ref: Optional[Annotated[str, Field(strict=True, max_length=128)]] = Field(default=None, description="Specifies your reference for the consent agreement that you have established with the customer. ", alias="consentAgreementRef")
    consent_agreement_src: StrictStr = Field(alias="consentAgreementSrc")
    network_transaction_id: Optional[Annotated[str, Field(strict=True, max_length=128)]] = Field(default=None, description="The ID of a network transaction. Only applicable if you set the `action` field to `Persist`. ", alias="networkTransactionId")
    status: StrictStr
    type: StrictStr
    __properties: ClassVar[List[str]] = ["action", "agreedOn", "authGateway", "cardSecurityCode", "consentAgreementRef", "consentAgreementSrc", "networkTransactionId", "status", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateStoredCredentialProfileRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateStoredCredentialProfileRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "action": obj.get("action"),
            "agreedOn": obj.get("agreedOn"),
            "authGateway": obj.get("authGateway"),
            "cardSecurityCode": obj.get("cardSecurityCode"),
            "consentAgreementRef": obj.get("consentAgreementRef"),
            "consentAgreementSrc": obj.get("consentAgreementSrc"),
            "networkTransactionId": obj.get("networkTransactionId"),
            "status": obj.get("status"),
            "type": obj.get("type")
        })
        return _obj


