# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.custom_object_all_fields_definition_all_of_created_by_id import CustomObjectAllFieldsDefinitionAllOfCreatedById
from zuora_sdk.models.custom_object_all_fields_definition_all_of_created_date import CustomObjectAllFieldsDefinitionAllOfCreatedDate
from zuora_sdk.models.custom_object_all_fields_definition_all_of_id import CustomObjectAllFieldsDefinitionAllOfId
from zuora_sdk.models.custom_object_all_fields_definition_all_of_updated_by_id import CustomObjectAllFieldsDefinitionAllOfUpdatedById
from zuora_sdk.models.custom_object_all_fields_definition_all_of_updated_date import CustomObjectAllFieldsDefinitionAllOfUpdatedDate
from typing import Optional, Set
from typing_extensions import Self

class CustomObjectAllFieldsDefinition(BaseModel):
    """
    The definitions of all the fields in the custom object definition
    """ # noqa: E501
    created_by_id: Optional[CustomObjectAllFieldsDefinitionAllOfCreatedById] = Field(default=None, alias="CreatedById")
    created_date: Optional[CustomObjectAllFieldsDefinitionAllOfCreatedDate] = Field(default=None, alias="CreatedDate")
    id: Optional[CustomObjectAllFieldsDefinitionAllOfId] = Field(default=None, alias="Id")
    updated_by_id: Optional[CustomObjectAllFieldsDefinitionAllOfUpdatedById] = Field(default=None, alias="UpdatedById")
    updated_date: Optional[CustomObjectAllFieldsDefinitionAllOfUpdatedDate] = Field(default=None, alias="UpdatedDate")
    __properties: ClassVar[List[str]] = ["CreatedById", "CreatedDate", "Id", "UpdatedById", "UpdatedDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CustomObjectAllFieldsDefinition from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of created_by_id
        if self.created_by_id:
            _dict['CreatedById'] = self.created_by_id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of created_date
        if self.created_date:
            _dict['CreatedDate'] = self.created_date.to_dict()
        # override the default output from pydantic by calling `to_dict()` of id
        if self.id:
            _dict['Id'] = self.id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of updated_by_id
        if self.updated_by_id:
            _dict['UpdatedById'] = self.updated_by_id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of updated_date
        if self.updated_date:
            _dict['UpdatedDate'] = self.updated_date.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CustomObjectAllFieldsDefinition from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "CreatedById": CustomObjectAllFieldsDefinitionAllOfCreatedById.from_dict(obj["CreatedById"]) if obj.get("CreatedById") is not None else None,
            "CreatedDate": CustomObjectAllFieldsDefinitionAllOfCreatedDate.from_dict(obj["CreatedDate"]) if obj.get("CreatedDate") is not None else None,
            "Id": CustomObjectAllFieldsDefinitionAllOfId.from_dict(obj["Id"]) if obj.get("Id") is not None else None,
            "UpdatedById": CustomObjectAllFieldsDefinitionAllOfUpdatedById.from_dict(obj["UpdatedById"]) if obj.get("UpdatedById") is not None else None,
            "UpdatedDate": CustomObjectAllFieldsDefinitionAllOfUpdatedDate.from_dict(obj["UpdatedDate"]) if obj.get("UpdatedDate") is not None else None
        })
        return _obj


