# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.custom_object_bulk_job_response_error import CustomObjectBulkJobResponseError
from typing import Optional, Set
from typing_extensions import Self

class CustomObjectBulkJobResponse(BaseModel):
    """
    CustomObjectBulkJobResponse
    """ # noqa: E501
    created_by_id: Optional[StrictStr] = Field(default=None, description="The ID of the user who creates the job.", alias="CreatedById")
    created_date: Optional[datetime] = Field(default=None, description="The time when the bulk job is created.", alias="CreatedDate")
    id: Optional[StrictStr] = Field(default=None, description="The custom object bulk job ID.", alias="Id")
    updated_by_id: Optional[StrictStr] = Field(default=None, description="The ID of the user who updates the job.", alias="UpdatedById")
    updated_date: Optional[datetime] = Field(default=None, description="The time when the bulk job is updated.", alias="UpdatedDate")
    error: Optional[CustomObjectBulkJobResponseError] = None
    namespace: Optional[StrictStr] = None
    object: Optional[StrictStr] = Field(default=None, description="The object to that the bulk operation performs on.")
    operation: Optional[StrictStr] = None
    processing_time: Optional[StrictInt] = Field(default=None, description="The amount of time elapsed, in milliseconds, from the submission to the completion of the bulk job.", alias="processingTime")
    records_processed: Optional[StrictInt] = Field(default=None, description="The number of object records processed by the bulk job.", alias="recordsProcessed")
    status: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["CreatedById", "CreatedDate", "Id", "UpdatedById", "UpdatedDate", "error", "namespace", "object", "operation", "processingTime", "recordsProcessed", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CustomObjectBulkJobResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of error
        if self.error:
            _dict['error'] = self.error.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CustomObjectBulkJobResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "CreatedById": obj.get("CreatedById"),
            "CreatedDate": obj.get("CreatedDate"),
            "Id": obj.get("Id"),
            "UpdatedById": obj.get("UpdatedById"),
            "UpdatedDate": obj.get("UpdatedDate"),
            "error": CustomObjectBulkJobResponseError.from_dict(obj["error"]) if obj.get("error") is not None else None,
            "namespace": obj.get("namespace"),
            "object": obj.get("object"),
            "operation": obj.get("operation"),
            "processingTime": obj.get("processingTime"),
            "recordsProcessed": obj.get("recordsProcessed"),
            "status": obj.get("status")
        })
        return _obj


