# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CustomObjectCustomFieldDefinitionUpdate(BaseModel):
    """
    The custom field definition in the custom object
    """ # noqa: E501
    default: Optional[StrictStr] = Field(default=None, description="Applicable if the `type` of the action is  `updateField`")
    description: Optional[StrictStr] = Field(default=None, description="Applicable if the `type` of the action is  `updateField`")
    display_name: Optional[StrictBool] = Field(default=None, description="Indicates whether to use this field as the display name of the custom object when being linked to another custom object.  This field applies only to the Text custom field type:  - The `type` field is `string`. - The `enum` field is not specified. ", alias="displayName")
    format: Optional[StrictStr] = Field(default=None, description="The data format of the custom field")
    label: Optional[StrictStr] = Field(default=None, description="The UI label of the custom field")
    max_length: Optional[StrictInt] = Field(default=None, description="The maximum length of string that can be stored in the custom field.  This field applies only to the following custom field types:  - Text:   - The `type` field is `string`.   - The `format` field is not specified or is `url`.   - The `enum` field is not specified. - Picklist:   - The `type` field is `string`.   - The `enum` field is specified.   - The `multiselect` field is not specified or is `false`. - Multiselect:   - The `type` field is `string`.   - The `enum` field is specified.   - The `multiselect` field is `true`.  If the custom field is filterable, the value of `maxLength` must be 512 or less. ", alias="maxLength")
    multiselect: Optional[StrictBool] = Field(default=None, description="Indicates whether this is a multiselect custom field.  This field applies only to the creation of Picklist or Multiselect custom fields:  - The action `type` field is `addField`. - The definition `type` field is `string`. - The `maxLength` field is specified. - The `enum` field is specified. ")
    origin: Optional[StrictStr] = None
    type: Optional[StrictStr] = Field(default=None, description="The data type of the custom field")
    __properties: ClassVar[List[str]] = ["default", "description", "displayName", "format", "label", "maxLength", "multiselect", "origin", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CustomObjectCustomFieldDefinitionUpdate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CustomObjectCustomFieldDefinitionUpdate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "default": obj.get("default"),
            "description": obj.get("description"),
            "displayName": obj.get("displayName"),
            "format": obj.get("format"),
            "label": obj.get("label"),
            "maxLength": obj.get("maxLength"),
            "multiselect": obj.get("multiselect"),
            "origin": obj.get("origin"),
            "type": obj.get("type")
        })
        return _obj


