# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.update_custom_object_cusotm_field import UpdateCustomObjectCusotmField
from typing import Optional, Set
from typing_extensions import Self

class CustomObjectDefinitionUpdateActionResponse(BaseModel):
    """
    CustomObjectDefinitionUpdateActionResponse
    """ # noqa: E501
    description: Optional[StrictStr] = Field(default=None, description="Optional property for `updateObject` action")
    enable_create_record_auditing: Optional[StrictBool] = Field(default=None, description="Indicates whether to audit the creation of custom object records of this custom object definition.", alias="enableCreateRecordAuditing")
    enable_delete_record_auditing: Optional[StrictBool] = Field(default=None, description="Indicates whether to audit the deletion of custom object records of this custom object definition.", alias="enableDeleteRecordAuditing")
    var_field: Optional[UpdateCustomObjectCusotmField] = Field(default=None, alias="field")
    label: Optional[StrictStr] = Field(default=None, description="Optional property for `updateObject` action")
    namespace: Optional[StrictStr] = Field(default=None, description="The namespace of the custom object definition to be updated")
    object: Optional[StrictStr] = Field(default=None, description="The API name of the custom object definition to be updated")
    relationship: Optional[Dict[str, Any]] = None
    type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["description", "enableCreateRecordAuditing", "enableDeleteRecordAuditing", "field", "label", "namespace", "object", "relationship", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CustomObjectDefinitionUpdateActionResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of var_field
        if self.var_field:
            _dict['field'] = self.var_field.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CustomObjectDefinitionUpdateActionResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "description": obj.get("description"),
            "enableCreateRecordAuditing": obj.get("enableCreateRecordAuditing"),
            "enableDeleteRecordAuditing": obj.get("enableDeleteRecordAuditing"),
            "field": UpdateCustomObjectCusotmField.from_dict(obj["field"]) if obj.get("field") is not None else None,
            "label": obj.get("label"),
            "namespace": obj.get("namespace"),
            "object": obj.get("object"),
            "relationship": obj.get("relationship"),
            "type": obj.get("type")
        })
        return _obj


