# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DeleteBatchQueryResponse(BaseModel):
    """
    DeleteBatchQueryResponse
    """ # noqa: E501
    batch_id: Optional[StrictStr] = Field(default=None, description="A 32-character ID of the query batch. ", alias="batchId")
    batch_type: Optional[StrictStr] = Field(default=None, alias="batchType")
    file_id: Optional[StrictStr] = Field(default=None, description="The ID of the query results file.  Use Get Results Files to download the query results file. The query results file is formatted as requested in the batch job. Supported formats are CSV, GZIP, and ZIP. ", alias="fileId")
    message: Optional[StrictStr] = Field(default=None, description="The error message. ")
    name: Optional[StrictStr] = Field(default=None, description="Name of the query supplied in the request. ")
    query: Optional[StrictStr] = Field(default=None, description="The requested query string. ")
    record_count: Optional[StrictStr] = Field(default=None, description="The number of records included in the query output file. ", alias="recordCount")
    segments: Optional[List[StrictStr]] = Field(default=None, description="Array of IDs of query results files. Replaces fileId for full data loads in stateful mode if <a href = \"https://knowledgecenter.zuora.com/Zuora_Central_Platform/API/AB_Aggregate_Query_API/G_File_Segmentation\" target=\"_blank\">File Segmentation</a> is enabled.  Use Get Results Files to download each query results file. Each query results file contains at most 500,000 records and is formatted as requested in the batch job. Supported formats are CSV, GZIP, and ZIP. ")
    status: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["batchId", "batchType", "fileId", "message", "name", "query", "recordCount", "segments", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DeleteBatchQueryResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DeleteBatchQueryResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "batchId": obj.get("batchId"),
            "batchType": obj.get("batchType"),
            "fileId": obj.get("fileId"),
            "message": obj.get("message"),
            "name": obj.get("name"),
            "query": obj.get("query"),
            "recordCount": obj.get("recordCount"),
            "segments": obj.get("segments"),
            "status": obj.get("status")
        })
        return _obj


