# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.delivery_frequency import DeliveryFrequency
from typing import Optional, Set
from typing_extensions import Self

class DeliverySchedule(BaseModel):
    """
    The `deliveryScheudule` is used for the Delivery Pricing charge model only.  To enable the Delivery Pricing charge model, submit a request at <a href=\"http://support.zuora.com/\" target=\"_blank\">Zuora Global Support</a> and check **Delivery Pricing** in **Billing Settings** > **Enable Charge Types / Models**. 
    """ # noqa: E501
    frequency: Optional[DeliveryFrequency] = None
    monday: Optional[StrictBool] = Field(default=None, description="Indicates whether delivery occurs on Monday.")
    tuesday: Optional[StrictBool] = Field(default=None, description="Indicates whether delivery occurs on Tuesday.")
    wednesday: Optional[StrictBool] = Field(default=None, description="Indicates whether delivery occurs on Wednesday.")
    thursday: Optional[StrictBool] = Field(default=None, description="Indicates whether delivery occurs on Thursday.")
    friday: Optional[StrictBool] = Field(default=None, description="Indicates whether delivery occurs on Friday.")
    saturday: Optional[StrictBool] = Field(default=None, description="Indicates whether delivery occurs on Saturday.")
    sunday: Optional[StrictBool] = Field(default=None, description="Indicates whether delivery occurs on Sunday.")
    __properties: ClassVar[List[str]] = ["frequency", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday", "sunday"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DeliverySchedule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DeliverySchedule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "frequency": obj.get("frequency"),
            "monday": obj.get("monday"),
            "tuesday": obj.get("tuesday"),
            "wednesday": obj.get("wednesday"),
            "thursday": obj.get("thursday"),
            "friday": obj.get("friday"),
            "saturday": obj.get("saturday"),
            "sunday": obj.get("sunday")
        })
        return _obj


