# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DiscountApplyDetail(BaseModel):
    """
    DiscountApplyDetail
    """ # noqa: E501
    applied_product_rate_plan_id: Optional[StrictStr] = Field(default=None, description="The ID of the product rate plan that the discount rate plan charge applies to. ", alias="appliedProductRatePlanId")
    applied_product_rate_plan_charge_id: Optional[StrictStr] = Field(default=None, description="The ID of the product rate plan charge that the discount rate plan charge applies to. ", alias="appliedProductRatePlanChargeId")
    applied_product_name: Optional[StrictStr] = Field(default=None, description="The name of the product that the discount rate plan charge applies to. ", alias="appliedProductName")
    applied_product_rate_plan_name: Optional[StrictStr] = Field(default=None, description="The name of the product rate plan that the discount rate plan charge applies to. ", alias="appliedProductRatePlanName")
    applied_product_rate_plan_charge_name: Optional[StrictStr] = Field(default=None, description="The name of the product rate plan charge that the discount rate plan charge applies to. ", alias="appliedProductRatePlanChargeName")
    __properties: ClassVar[List[str]] = ["appliedProductRatePlanId", "appliedProductRatePlanChargeId", "appliedProductName", "appliedProductRatePlanName", "appliedProductRatePlanChargeName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DiscountApplyDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DiscountApplyDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "appliedProductRatePlanId": obj.get("appliedProductRatePlanId"),
            "appliedProductRatePlanChargeId": obj.get("appliedProductRatePlanChargeId"),
            "appliedProductName": obj.get("appliedProductName"),
            "appliedProductRatePlanName": obj.get("appliedProductRatePlanName"),
            "appliedProductRatePlanChargeName": obj.get("appliedProductRatePlanChargeName")
        })
        return _obj


