# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class EmailBillingDocumentRequest(BaseModel):
    """
    EmailBillingDocumentRequest
    """ # noqa: E501
    email_addresses: Optional[StrictStr] = Field(default=None, description="The valid email addresses you want to email a billing document to. Use commas to separate email addresses.  **Note:** This field is only applicable if you set the `useEmailTemplateSetting` field to `false`. ", alias="emailAddresses")
    include_additional_email_addresses: Optional[StrictBool] = Field(default=False, description="Indicates whether to send a billing document to the additional email addresses of the memo account.    You can set the additional email addresses in the **Additional Email Addresses** field on the account detail page from the Zuora UI. See [Create a Customer Account](https://knowledgecenter.zuora.com/BC_Subscription_Management/Customer_Accounts/B_Create_a_Customer_Account#section_2) for more information. ", alias="includeAdditionalEmailAddresses")
    pdf_file_id: Optional[StrictStr] = Field(default=None, description="The ID of the PDF file that you want to send in the email.   If you do not specify any PDF file ID, the latest PDF file generated for the billing document is sent in the email. ", alias="pdfFileId")
    use_email_template_setting: Optional[StrictBool] = Field(default=False, description="Indicates whether to email a billing document based on the email template setting.   If you set this field to `true`, the billing document is sent to the email addresses specified in the **To Email** field of the email template. The email template is the one you set in the **Delivery Options** panel of the **Edit notification** dialog from the Zuora UI. See [Edit Email Templates](https://knowledgecenter.zuora.com/CF_Users_and_Administrators/Notifications/Create_Email_Templates) for more information about how to edit the **To Email** field in the email template. ", alias="useEmailTemplateSetting")
    __properties: ClassVar[List[str]] = ["emailAddresses", "includeAdditionalEmailAddresses", "pdfFileId", "useEmailTemplateSetting"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EmailBillingDocumentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EmailBillingDocumentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "emailAddresses": obj.get("emailAddresses"),
            "includeAdditionalEmailAddresses": obj.get("includeAdditionalEmailAddresses") if obj.get("includeAdditionalEmailAddresses") is not None else False,
            "pdfFileId": obj.get("pdfFileId"),
            "useEmailTemplateSetting": obj.get("useEmailTemplateSetting") if obj.get("useEmailTemplateSetting") is not None else False
        })
        return _obj


