# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GenerateBillingDocumentRequest(BaseModel):
    """
    GenerateBillingDocumentRequest
    """ # noqa: E501
    auto_post: Optional[StrictBool] = Field(default=False, description="Whether to automatically post the billing documents after the draft billing documents are generated.   If an error occurs during posting billing documents, the draft billing documents are not generated too. ", alias="autoPost")
    auto_renew: Optional[StrictBool] = Field(default=False, description="Whether to automatically renew the subscriptions with **Auto Renew** set to **Yes**.  ", alias="autoRenew")
    charge_type_to_exclude: Optional[List[StrictStr]] = Field(default=None, description="The types of the charges to be excluded from the generation of billing documents. The field values are case insensitive. Supported values include `onetime`, `recurring`, and `usage`.  ", alias="chargeTypeToExclude")
    credit_memo_reason_code: Optional[StrictStr] = Field(default=None, description="A code identifying the reason for the credit memo transaction that is generated by the request. The value must be an existing reason code. If you do not pass the field or pass the field with empty value, Zuora uses the default reason code.", alias="creditMemoReasonCode")
    effective_date: Optional[date] = Field(default=None, description="The date on which to generate the billing documents, in `yyyy-mm-dd` format. ", alias="effectiveDate")
    subscription_ids: Optional[List[StrictStr]] = Field(default=None, description="The IDs of the subscriptions that you want to create the billing documents for. Each value must be the ID of the latest version of an active subscription. ", alias="subscriptionIds")
    target_date: Optional[date] = Field(default=None, description="The date used to determine which charges are to be billed, in `yyyy-mm-dd` format. ", alias="targetDate")
    __properties: ClassVar[List[str]] = ["autoPost", "autoRenew", "chargeTypeToExclude", "creditMemoReasonCode", "effectiveDate", "subscriptionIds", "targetDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GenerateBillingDocumentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GenerateBillingDocumentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "autoPost": obj.get("autoPost") if obj.get("autoPost") is not None else False,
            "autoRenew": obj.get("autoRenew") if obj.get("autoRenew") is not None else False,
            "chargeTypeToExclude": obj.get("chargeTypeToExclude"),
            "creditMemoReasonCode": obj.get("creditMemoReasonCode"),
            "effectiveDate": obj.get("effectiveDate"),
            "subscriptionIds": obj.get("subscriptionIds"),
            "targetDate": obj.get("targetDate")
        })
        return _obj


