# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetAccountingPeriodAllOfFieIdsResponse(BaseModel):
    """
    File IDs of the reports available for the accounting period. You can retrieve the reports by specifying the file ID in a [Get Files](https://www.zuora.com/developer/api-references/api/operation/Get_Files) REST API call. 
    """ # noqa: E501
    accounts_receivable_account_aging_detail_export_file_id: Optional[StrictStr] = Field(default=None, description="File ID of the Accounts Receivable Aging Account Detail report. ", alias="accountsReceivableAccountAgingDetailExportFileId")
    accounts_receivable_invoice_aging_detail_export_file_id: Optional[StrictStr] = Field(default=None, description="File ID of the Accounts Receivable Aging Invoice Detail report. ", alias="accountsReceivableInvoiceAgingDetailExportFileId")
    ar_roll_forward_detail_export_file_id: Optional[StrictStr] = Field(default=None, description="File ID of the Accounts Receivable Detail report. ", alias="arRollForwardDetailExportFileId")
    fx_realized_gain_and_loss_detail_export_file_id: Optional[StrictStr] = Field(default=None, description="File ID of the Realized Gain and Loss Detail report.  Returned only if you have Foreign Currency Conversion enabled. ", alias="fxRealizedGainAndLossDetailExportFileId")
    fx_unrealized_gain_and_loss_detail_export_file_id: Optional[StrictStr] = Field(default=None, description="File ID of the Unrealized Gain and Loss Detail report.  Returned only if you have Foreign Currency Conversion enabled ", alias="fxUnrealizedGainAndLossDetailExportFileId")
    revenue_detail_csv_file_id: Optional[StrictStr] = Field(default=None, description="File ID of the Revenue Detail report in CSV format. ", alias="revenueDetailCsvFileId")
    revenue_detail_excel_file_id: Optional[StrictStr] = Field(default=None, description="File ID of the Revenue Detail report in XLSX format. ", alias="revenueDetailExcelFileId")
    unprocessed_charges_file_id: Optional[StrictStr] = Field(default=None, description="File ID of a report containing all unprocessed charges for the accounting period. ", alias="unprocessedChargesFileId")
    __properties: ClassVar[List[str]] = ["accountsReceivableAccountAgingDetailExportFileId", "accountsReceivableInvoiceAgingDetailExportFileId", "arRollForwardDetailExportFileId", "fxRealizedGainAndLossDetailExportFileId", "fxUnrealizedGainAndLossDetailExportFileId", "revenueDetailCsvFileId", "revenueDetailExcelFileId", "unprocessedChargesFileId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetAccountingPeriodAllOfFieIdsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetAccountingPeriodAllOfFieIdsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountsReceivableAccountAgingDetailExportFileId": obj.get("accountsReceivableAccountAgingDetailExportFileId"),
            "accountsReceivableInvoiceAgingDetailExportFileId": obj.get("accountsReceivableInvoiceAgingDetailExportFileId"),
            "arRollForwardDetailExportFileId": obj.get("arRollForwardDetailExportFileId"),
            "fxRealizedGainAndLossDetailExportFileId": obj.get("fxRealizedGainAndLossDetailExportFileId"),
            "fxUnrealizedGainAndLossDetailExportFileId": obj.get("fxUnrealizedGainAndLossDetailExportFileId"),
            "revenueDetailCsvFileId": obj.get("revenueDetailCsvFileId"),
            "revenueDetailExcelFileId": obj.get("revenueDetailExcelFileId"),
            "unprocessedChargesFileId": obj.get("unprocessedChargesFileId")
        })
        return _obj


