# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.failed_reason import FailedReason
from typing import Optional, Set
from typing_extensions import Self

class GetAttachmentResponse(BaseModel):
    """
    GetAttachmentResponse
    """ # noqa: E501
    process_id: Optional[StrictStr] = Field(default=None, description="The Id of the process that handle the operation. ", alias="processId")
    request_id: Optional[StrictStr] = Field(default=None, description="The request ID of this process. ", alias="requestId")
    reasons: Optional[List[FailedReason]] = None
    success: Optional[StrictBool] = Field(default=None, description="Returns `true` if the request was processed successfully. ")
    created_by: Optional[StrictStr] = Field(default=None, description="Zuora user id who added this attachment to the object. ", alias="createdBy")
    created_on: Optional[StrictStr] = Field(default=None, description="Date and time when the attachment was added to the object. ", alias="createdOn")
    description: Optional[StrictStr] = Field(default=None, description="Description of the attachment. ")
    file_content_type: Optional[StrictStr] = Field(default=None, description="File type. ", alias="fileContentType")
    file_id: Optional[StrictStr] = Field(default=None, description="File ID of the attached file. Use this file ID with [Get files](https://www.zuora.com/developer/api-references/api/operation/Get_Files) to download the file. ", alias="fileId")
    file_name: Optional[StrictStr] = Field(default=None, description="Attachment file name. ", alias="fileName")
    id: Optional[StrictStr] = Field(default=None, description="Id of this attachment. ")
    updated_by: Optional[StrictStr] = Field(default=None, description="Zuora user id who last updated the attachment. ", alias="updatedBy")
    updated_on: Optional[StrictStr] = Field(default=None, description="Date and time when the attachment was last updated. ", alias="updatedOn")
    __properties: ClassVar[List[str]] = ["processId", "requestId", "reasons", "success", "createdBy", "createdOn", "description", "fileContentType", "fileId", "fileName", "id", "updatedBy", "updatedOn"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetAttachmentResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in reasons (list)
        _items = []
        if self.reasons:
            for _item in self.reasons:
                if _item:
                    _items.append(_item.to_dict())
            _dict['reasons'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetAttachmentResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "processId": obj.get("processId"),
            "requestId": obj.get("requestId"),
            "reasons": [FailedReason.from_dict(_item) for _item in obj["reasons"]] if obj.get("reasons") is not None else None,
            "success": obj.get("success"),
            "createdBy": obj.get("createdBy"),
            "createdOn": obj.get("createdOn"),
            "description": obj.get("description"),
            "fileContentType": obj.get("fileContentType"),
            "fileId": obj.get("fileId"),
            "fileName": obj.get("fileName"),
            "id": obj.get("id"),
            "updatedBy": obj.get("updatedBy"),
            "updatedOn": obj.get("updatedOn")
        })
        return _obj


