# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetCalloutHistoryVOType(BaseModel):
    """
    GetCalloutHistoryVOType
    """ # noqa: E501
    attempted_num: Optional[StrictStr] = Field(default=None, description="The number of times the callout was retried. ", alias="attemptedNum")
    create_time: Optional[StrictStr] = Field(default=None, description="The time that the calloutHistory record was made. ", alias="createTime")
    event_category: Optional[StrictStr] = Field(default=None, description="The event category for the callout. ", alias="eventCategory")
    event_context: Optional[StrictStr] = Field(default=None, description="The context of the callout event. ", alias="eventContext")
    notification: Optional[StrictStr] = Field(default=None, description="The name of the notification. ")
    request_method: Optional[StrictStr] = Field(default=None, description="The request method set in notifications settings. ", alias="requestMethod")
    request_url: Optional[StrictStr] = Field(default=None, description="The base url set in notifications settings. ", alias="requestUrl")
    response_code: Optional[StrictStr] = Field(default=None, description="The responseCode of the request. ", alias="responseCode")
    response_content: Optional[StrictStr] = Field(default=None, alias="responseContent")
    __properties: ClassVar[List[str]] = ["attemptedNum", "createTime", "eventCategory", "eventContext", "notification", "requestMethod", "requestUrl", "responseCode", "responseContent"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetCalloutHistoryVOType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetCalloutHistoryVOType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "attemptedNum": obj.get("attemptedNum"),
            "createTime": obj.get("createTime"),
            "eventCategory": obj.get("eventCategory"),
            "eventContext": obj.get("eventContext"),
            "notification": obj.get("notification"),
            "requestMethod": obj.get("requestMethod"),
            "requestUrl": obj.get("requestUrl"),
            "responseCode": obj.get("responseCode"),
            "responseContent": obj.get("responseContent")
        })
        return _obj


