# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetDebitMemoItemFinanceInformation(BaseModel):
    """
    Container for the finance information related to the debit memo item. 
    """ # noqa: E501
    deferred_revenue_accounting_code: Optional[StrictStr] = Field(default=None, description="The accounting code for the deferred revenue, such as Monthly Recurring Liability. ", alias="deferredRevenueAccountingCode")
    deferred_revenue_accounting_code_type: Optional[StrictStr] = Field(default=None, description="The type of the deferred revenue accounting code, such as Deferred Revenue. ", alias="deferredRevenueAccountingCodeType")
    recognized_revenue_accounting_code: Optional[StrictStr] = Field(default=None, description="The accounting code for the recognized revenue, such as Monthly Recurring Charges or Overage Charges. ", alias="recognizedRevenueAccountingCode")
    recognized_revenue_accounting_code_type: Optional[StrictStr] = Field(default=None, description="The type of the recognized revenue accounting code, such as Sales Revenue or Sales Discount. ", alias="recognizedRevenueAccountingCodeType")
    revenue_recognition_rule_name: Optional[StrictStr] = Field(default=None, description="The name of the revenue recognition rule governing the revenue schedule. ", alias="revenueRecognitionRuleName")
    revenue_schedule_number: Optional[StrictStr] = Field(default=None, description="The revenue schedule number. The revenue schedule number is always prefixed with \"RS\", for example, RS-00000001. ", alias="revenueScheduleNumber")
    __properties: ClassVar[List[str]] = ["deferredRevenueAccountingCode", "deferredRevenueAccountingCodeType", "recognizedRevenueAccountingCode", "recognizedRevenueAccountingCodeType", "revenueRecognitionRuleName", "revenueScheduleNumber"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetDebitMemoItemFinanceInformation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetDebitMemoItemFinanceInformation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "deferredRevenueAccountingCode": obj.get("deferredRevenueAccountingCode"),
            "deferredRevenueAccountingCodeType": obj.get("deferredRevenueAccountingCodeType"),
            "recognizedRevenueAccountingCode": obj.get("recognizedRevenueAccountingCode"),
            "recognizedRevenueAccountingCodeType": obj.get("recognizedRevenueAccountingCodeType"),
            "revenueRecognitionRuleName": obj.get("revenueRecognitionRuleName"),
            "revenueScheduleNumber": obj.get("revenueScheduleNumber")
        })
        return _obj


