# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetDebitMemoPdfStatusResponse(BaseModel):
    """
    GetDebitMemoPdfStatusResponse
    """ # noqa: E501
    debit_memo_id: Optional[StrictStr] = Field(default=None, description="The ID of the debit memo whose pdf status is requested. ", alias="debitMemoId")
    debit_memo_number: Optional[StrictStr] = Field(default=None, description="The debit memo number of the debit memo whose pdf status is requested. ", alias="debitMemoNumber")
    pdf_generation_status: Optional[StrictStr] = Field(default=None, description="The generation status of the debit memo PDF. Can be one of - None/Pending/Processing/Generated/Error/Obsolete/Archived ", alias="pdfGenerationStatus")
    created_on: Optional[StrictStr] = Field(default=None, description="The time at which the request to generate the PDF was created. ", alias="createdOn")
    updated_on: Optional[StrictStr] = Field(default=None, description="The time at which the request to generate the PDF was updated. ", alias="updatedOn")
    __properties: ClassVar[List[str]] = ["debitMemoId", "debitMemoNumber", "pdfGenerationStatus", "createdOn", "updatedOn"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetDebitMemoPdfStatusResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetDebitMemoPdfStatusResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "debitMemoId": obj.get("debitMemoId"),
            "debitMemoNumber": obj.get("debitMemoNumber"),
            "pdfGenerationStatus": obj.get("pdfGenerationStatus"),
            "createdOn": obj.get("createdOn"),
            "updatedOn": obj.get("updatedOn")
        })
        return _obj


