# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class GetInvoiceApplicationPartRequest(BaseModel):
    """
    GetInvoiceApplicationPartRequest
    """ # noqa: E501
    applied_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The amount that is applied to the invoice. ", alias="appliedAmount")
    created_by_id: Optional[StrictStr] = Field(default=None, description="The ID of the Zuora user who created the payment or credit memo. ", alias="createdById")
    created_date: Optional[datetime] = Field(default=None, description="The date and time when the payment or credit memo was created, in `yyyy-mm-dd hh:mm:ss` format. For example, 2017-12-01 15:31:10. ", alias="createdDate")
    credit_memo_id: Optional[StrictStr] = Field(default=None, description="The ID of credit memo that is applied to the specified invoice. ", alias="creditMemoId")
    payment_id: Optional[StrictStr] = Field(default=None, description="The ID of the payment that is applied to the specified invoice. ", alias="paymentId")
    updated_by_id: Optional[StrictStr] = Field(default=None, description="The ID of the Zuora user who last updated the payment or credit memo. ", alias="updatedById")
    updated_date: Optional[datetime] = Field(default=None, description="The date and time when the payment or credit memo was last updated, in `yyyy-mm-dd hh:mm:ss` format. For example, 2018-01-02 11:42:16. ", alias="updatedDate")
    __properties: ClassVar[List[str]] = ["appliedAmount", "createdById", "createdDate", "creditMemoId", "paymentId", "updatedById", "updatedDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetInvoiceApplicationPartRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetInvoiceApplicationPartRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "appliedAmount": obj.get("appliedAmount"),
            "createdById": obj.get("createdById"),
            "createdDate": obj.get("createdDate"),
            "creditMemoId": obj.get("creditMemoId"),
            "paymentId": obj.get("paymentId"),
            "updatedById": obj.get("updatedById"),
            "updatedDate": obj.get("updatedDate")
        })
        return _obj


