# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetPaymentMethodResponseGooglePayForAccount(BaseModel):
    """
    GetPaymentMethodResponseGooglePayForAccount
    """ # noqa: E501
    google_bin: Optional[StrictStr] = Field(default=None, description="This field is only available for Google Pay payment methods. ", alias="googleBIN")
    google_card_number: Optional[StrictStr] = Field(default=None, description="This field is only available for Google Pay payment methods. ", alias="googleCardNumber")
    google_card_type: Optional[StrictStr] = Field(default=None, description="This field is only available for Google Pay payment methods.  For Google Pay payment methods on Adyen, the first 100 characters of [paymentMethodVariant](https://docs.adyen.com/development-resources/paymentmethodvariant) returned from Adyen are stored in this field. ", alias="googleCardType")
    google_expiry_date: Optional[StrictStr] = Field(default=None, description="This field is only available for Google Pay payment methods. ", alias="googleExpiryDate")
    google_gateway_token: Optional[StrictStr] = Field(default=None, description="This field is only available for Google Pay payment methods. ", alias="googleGatewayToken")
    __properties: ClassVar[List[str]] = ["googleBIN", "googleCardNumber", "googleCardType", "googleExpiryDate", "googleGatewayToken"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetPaymentMethodResponseGooglePayForAccount from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetPaymentMethodResponseGooglePayForAccount from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "googleBIN": obj.get("googleBIN"),
            "googleCardNumber": obj.get("googleCardNumber"),
            "googleCardType": obj.get("googleCardType"),
            "googleExpiryDate": obj.get("googleExpiryDate"),
            "googleGatewayToken": obj.get("googleGatewayToken")
        })
        return _obj


