# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GetPaymentRunSummaryTotalValuesResponse(BaseModel):
    """
    GetPaymentRunSummaryTotalValuesResponse
    """ # noqa: E501
    total_value_of_credit_balance: Optional[StrictStr] = Field(default=None, description="**Note:** This field is only available if you have the Credit Balance feature enabled.  The total amount of credit balance after the payment run is completed. ", alias="totalValueOfCreditBalance")
    total_value_of_credit_memos: Optional[StrictStr] = Field(default=None, description="**Note:** This field is only available if you have the Invoice Settlement feature enabled.  The total amount of credit memos that are successfully processed in the payment run. ", alias="totalValueOfCreditMemos")
    total_value_of_debit_memos: Optional[StrictStr] = Field(default=None, description="**Note:** This field is only available if you have the Invoice Settlement feature enabled.  The total amount of debit memos that are picked up for processing in the payment run. ", alias="totalValueOfDebitMemos")
    total_value_of_errors: Optional[StrictStr] = Field(default=None, description="The total amount of receivables associated with the payments with the status of `Error` and `Processing`. ", alias="totalValueOfErrors")
    total_value_of_invoices: Optional[StrictStr] = Field(default=None, description="**Note:** This field is only available if you have the Invoice Settlement feature enabled.  The total amount of invoices that are picked up for processing in the payment run. ", alias="totalValueOfInvoices")
    total_value_of_payments: Optional[StrictStr] = Field(default=None, description="The total amount of payments that are successfully processed in the payment run. ", alias="totalValueOfPayments")
    total_value_of_receivables: Optional[StrictStr] = Field(default=None, description="The total amount of receivables associated with the payment run.  The value of this field is the sum of the value of the `totalValueOfInvoices` field and that of the `totalValueOfDebitMemos` field. ", alias="totalValueOfReceivables")
    total_value_of_unapplied_payments: Optional[StrictStr] = Field(default=None, description="**Note:** This field is only available if you have the Invoice Settlement feature enabled.  The total amount of unapplied payments that are successfully processed in the payment run. ", alias="totalValueOfUnappliedPayments")
    total_value_of_unprocessed_debit_memos: Optional[StrictStr] = Field(default=None, description="**Note:** This field is only available if you have the Invoice Settlement feature enabled.  The total amount of debit memos with remaining positive balances after the payment run is completed. ", alias="totalValueOfUnprocessedDebitMemos")
    total_value_of_unprocessed_invoices: Optional[StrictStr] = Field(default=None, description="**Note:** This field is only available if you have the Invoice Settlement feature enabled.  The total amount of invoices with remaining positive balances after the payment run is completed. ", alias="totalValueOfUnprocessedInvoices")
    total_value_of_unprocessed_receivables: Optional[StrictStr] = Field(default=None, description="The total amount of receivables with remaining positive balances after the payment run is completed. ", alias="totalValueOfUnprocessedReceivables")
    __properties: ClassVar[List[str]] = ["totalValueOfCreditBalance", "totalValueOfCreditMemos", "totalValueOfDebitMemos", "totalValueOfErrors", "totalValueOfInvoices", "totalValueOfPayments", "totalValueOfReceivables", "totalValueOfUnappliedPayments", "totalValueOfUnprocessedDebitMemos", "totalValueOfUnprocessedInvoices", "totalValueOfUnprocessedReceivables"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetPaymentRunSummaryTotalValuesResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetPaymentRunSummaryTotalValuesResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "totalValueOfCreditBalance": obj.get("totalValueOfCreditBalance"),
            "totalValueOfCreditMemos": obj.get("totalValueOfCreditMemos"),
            "totalValueOfDebitMemos": obj.get("totalValueOfDebitMemos"),
            "totalValueOfErrors": obj.get("totalValueOfErrors"),
            "totalValueOfInvoices": obj.get("totalValueOfInvoices"),
            "totalValueOfPayments": obj.get("totalValueOfPayments"),
            "totalValueOfReceivables": obj.get("totalValueOfReceivables"),
            "totalValueOfUnappliedPayments": obj.get("totalValueOfUnappliedPayments"),
            "totalValueOfUnprocessedDebitMemos": obj.get("totalValueOfUnprocessedDebitMemos"),
            "totalValueOfUnprocessedInvoices": obj.get("totalValueOfUnprocessedInvoices"),
            "totalValueOfUnprocessedReceivables": obj.get("totalValueOfUnprocessedReceivables")
        })
        return _obj


