# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.get_payment_run_statistic_response import GetPaymentRunStatisticResponse
from zuora_sdk.models.get_payment_schedule_statistic_response_payment_schedule_items import GetPaymentScheduleStatisticResponsePaymentScheduleItems
from typing import Optional, Set
from typing_extensions import Self

class GetPaymentScheduleStatisticResponse(BaseModel):
    """
    The object that contains the payment schedule statistic of the specified date. 
    """ # noqa: E501
    var_date: Optional[date] = Field(default=None, description="The specified date. ", alias="date")
    payment_runs: Optional[List[GetPaymentRunStatisticResponse]] = Field(default=None, alias="paymentRuns")
    payment_schedule_items: Optional[GetPaymentScheduleStatisticResponsePaymentScheduleItems] = Field(default=None, alias="paymentScheduleItems")
    success: Optional[StrictBool] = Field(default=None, description="Returns `true` if the request was processed successfully. ")
    __properties: ClassVar[List[str]] = ["date", "paymentRuns", "paymentScheduleItems", "success"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetPaymentScheduleStatisticResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in payment_runs (list)
        _items = []
        if self.payment_runs:
            for _item in self.payment_runs:
                if _item:
                    _items.append(_item.to_dict())
            _dict['paymentRuns'] = _items
        # override the default output from pydantic by calling `to_dict()` of payment_schedule_items
        if self.payment_schedule_items:
            _dict['paymentScheduleItems'] = self.payment_schedule_items.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetPaymentScheduleStatisticResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "date": obj.get("date"),
            "paymentRuns": [GetPaymentRunStatisticResponse.from_dict(_item) for _item in obj["paymentRuns"]] if obj.get("paymentRuns") is not None else None,
            "paymentScheduleItems": GetPaymentScheduleStatisticResponsePaymentScheduleItems.from_dict(obj["paymentScheduleItems"]) if obj.get("paymentScheduleItems") is not None else None,
            "success": obj.get("success")
        })
        return _obj


