# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from zuora_sdk.models.price_format_product_rate_plan_charge_tier import PriceFormatProductRatePlanChargeTier
from typing import Optional, Set
from typing_extensions import Self

class GetProductRatePlanChargeTierResponse(BaseModel):
    """
    GetProductRatePlanChargeTierResponse
    """ # noqa: E501
    created_by_id: Optional[Annotated[str, Field(strict=True, max_length=32)]] = Field(default=None, description="The ID of the Zuora user who created the ProductRatePlanChargeTier object. ", alias="CreatedById")
    created_date: Optional[datetime] = Field(default=None, description="The date when the ProductRatePlanChargeTier object was created. ", alias="CreatedDate")
    currency: Optional[Annotated[str, Field(strict=True, max_length=3)]] = Field(default=None, description="The valid code corresponding to the currency for the tier's price. ", alias="Currency")
    ending_unit: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The end number of a range of units for the tier.  **Character limit**: 16  **Values**: any positive decimal value ", alias="EndingUnit")
    id: Optional[StrictStr] = Field(default=None, description="Object identifier.", alias="Id")
    price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The price of the tier if the charge is a flat fee, or the price of each unit in the tier if the charge model is tiered pricing.  **Character limit**: 16  **Values**: a valid currency value ", alias="Price")
    price_format: Optional[PriceFormatProductRatePlanChargeTier] = Field(default=None, alias="PriceFormat")
    starting_unit: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The starting number of a range of units for the tier.  **Character limit**: 16  **Values**: any positive decimal value ", alias="StartingUnit")
    tier: Optional[StrictInt] = Field(default=None, description="A unique number that identifies the tier that the price applies to.  **Character limit**: 20  **Values**: automatically generated ", alias="Tier")
    updated_by_id: Optional[Annotated[str, Field(strict=True, max_length=32)]] = Field(default=None, description="The ID of the user who last updated the product rate plan charge tier. ", alias="UpdatedById")
    updated_date: Optional[datetime] = Field(default=None, description="The date when the product rate plan charge tier was last updated. ", alias="UpdatedDate")
    __properties: ClassVar[List[str]] = ["CreatedById", "CreatedDate", "Currency", "EndingUnit", "Id", "Price", "PriceFormat", "StartingUnit", "Tier", "UpdatedById", "UpdatedDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetProductRatePlanChargeTierResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetProductRatePlanChargeTierResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "CreatedById": obj.get("CreatedById"),
            "CreatedDate": obj.get("CreatedDate"),
            "Currency": obj.get("Currency"),
            "EndingUnit": obj.get("EndingUnit"),
            "Id": obj.get("Id"),
            "Price": obj.get("Price"),
            "PriceFormat": obj.get("PriceFormat"),
            "StartingUnit": obj.get("StartingUnit"),
            "Tier": obj.get("Tier"),
            "UpdatedById": obj.get("UpdatedById"),
            "UpdatedDate": obj.get("UpdatedDate")
        })
        return _obj


