# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class GetPublicEmailTemplateResponse(BaseModel):
    """
    GetPublicEmailTemplateResponse
    """ # noqa: E501
    active: Optional[StrictBool] = Field(default=None, description="The status of the email template.")
    bcc_email_address: Optional[StrictStr] = Field(default=None, description="Email BCC address.", alias="bccEmailAddress")
    cc_email_address: Optional[StrictStr] = Field(default=None, description="Email CC address.", alias="ccEmailAddress")
    cc_email_type: Optional[StrictStr] = Field(default=None, alias="ccEmailType")
    created_by: Optional[StrictStr] = Field(default=None, description="The ID of the user who created the email template.", alias="createdBy")
    created_on: Optional[datetime] = Field(default=None, description="The time when the email template was created. Specified in the UTC timezone in the ISO860 format (YYYY-MM-DDThh:mm:ss.sTZD). E.g. 1997-07-16T19:20:30.45+00:00", alias="createdOn")
    description: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="The description of the email template.")
    email_body: Optional[StrictStr] = Field(default=None, description="The email body. You can add merge fields in the email object using angle brackets.  User can also embed html tags if `isHtml` is `true`.", alias="emailBody")
    email_subject: Optional[StrictStr] = Field(default=None, description="The email subject. You can add merge fields in the email subject using angle brackets.", alias="emailSubject")
    encoding_type: Optional[StrictStr] = Field(default=None, alias="encodingType")
    event_category: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The event category code for a standard event. See [Standard Event Categories](https://knowledgecenter.zuora.com/Central_Platform/Notifications/A_Standard_Events/Standard_Event_Category_Code_for_Notification_Histories_API) for all event category codes.", alias="eventCategory")
    event_type_name: Optional[Annotated[str, Field(min_length=1, strict=True)]] = Field(default=None, description="The name of the custom event or custom scheduled event.", alias="eventTypeName")
    event_type_namespace: Optional[StrictStr] = Field(default=None, description="The namespace of the `eventTypeName` field for custom events and custom scheduled events.  ", alias="eventTypeNamespace")
    from_email_address: Optional[StrictStr] = Field(default=None, description="If formEmailType is SpecificEmail, this field is required.", alias="fromEmailAddress")
    from_email_type: Optional[StrictStr] = Field(default=None, alias="fromEmailType")
    from_name: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="The name of email sender.", alias="fromName")
    id: Optional[StrictStr] = Field(default=None, description="The email template ID.")
    is_html: Optional[StrictBool] = Field(default=None, description="Indicates whether the style of email body is HTML.", alias="isHtml")
    name: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="The name of the email template.")
    reply_to_email_address: Optional[StrictStr] = Field(default=None, description="If replyToEmailType is SpecificEmail, this field is required", alias="replyToEmailAddress")
    reply_to_email_type: Optional[StrictStr] = Field(default=None, alias="replyToEmailType")
    to_email_address: Optional[StrictStr] = Field(default=None, description="If `toEmailType` is `SpecificEmail`, this field is required.", alias="toEmailAddress")
    to_email_type: Optional[StrictStr] = Field(default=None, alias="toEmailType")
    updated_by: Optional[StrictStr] = Field(default=None, description="The ID of the user who updated the email template.", alias="updatedBy")
    updated_on: Optional[datetime] = Field(default=None, description="The time when the email template was updated. Specified in the UTC timezone in the ISO860 format (YYYY-MM-DDThh:mm:ss.sTZD). E.g. 1997-07-16T19:20:30.45+00:00", alias="updatedOn")
    __properties: ClassVar[List[str]] = ["active", "bccEmailAddress", "ccEmailAddress", "ccEmailType", "createdBy", "createdOn", "description", "emailBody", "emailSubject", "encodingType", "eventCategory", "eventTypeName", "eventTypeNamespace", "fromEmailAddress", "fromEmailType", "fromName", "id", "isHtml", "name", "replyToEmailAddress", "replyToEmailType", "toEmailAddress", "toEmailType", "updatedBy", "updatedOn"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetPublicEmailTemplateResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetPublicEmailTemplateResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "active": obj.get("active"),
            "bccEmailAddress": obj.get("bccEmailAddress"),
            "ccEmailAddress": obj.get("ccEmailAddress"),
            "ccEmailType": obj.get("ccEmailType"),
            "createdBy": obj.get("createdBy"),
            "createdOn": obj.get("createdOn"),
            "description": obj.get("description"),
            "emailBody": obj.get("emailBody"),
            "emailSubject": obj.get("emailSubject"),
            "encodingType": obj.get("encodingType"),
            "eventCategory": obj.get("eventCategory"),
            "eventTypeName": obj.get("eventTypeName"),
            "eventTypeNamespace": obj.get("eventTypeNamespace"),
            "fromEmailAddress": obj.get("fromEmailAddress"),
            "fromEmailType": obj.get("fromEmailType"),
            "fromName": obj.get("fromName"),
            "id": obj.get("id"),
            "isHtml": obj.get("isHtml"),
            "name": obj.get("name"),
            "replyToEmailAddress": obj.get("replyToEmailAddress"),
            "replyToEmailType": obj.get("replyToEmailType"),
            "toEmailAddress": obj.get("toEmailAddress"),
            "toEmailType": obj.get("toEmailType"),
            "updatedBy": obj.get("updatedBy"),
            "updatedOn": obj.get("updatedOn")
        })
        return _obj


