# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from zuora_sdk.models.interval_pricing_tier import IntervalPricingTier
from typing import Optional, Set
from typing_extensions import Self

class IntervalPricing(BaseModel):
    """
    IntervalPricing
    """ # noqa: E501
    sequence: Optional[StrictInt] = None
    type: Optional[StrictStr] = None
    duration: Optional[StrictInt] = None
    price: Optional[Union[StrictFloat, StrictInt]] = None
    subscription_charge_interval_price_tiers: Optional[IntervalPricingTier] = Field(default=None, alias="subscriptionChargeIntervalPriceTiers")
    __properties: ClassVar[List[str]] = ["sequence", "type", "duration", "price", "subscriptionChargeIntervalPriceTiers"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Day', 'Month', 'Infinity']):
            raise ValueError("must be one of enum values ('Day', 'Month', 'Infinity')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IntervalPricing from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of subscription_charge_interval_price_tiers
        if self.subscription_charge_interval_price_tiers:
            _dict['subscriptionChargeIntervalPriceTiers'] = self.subscription_charge_interval_price_tiers.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IntervalPricing from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sequence": obj.get("sequence"),
            "type": obj.get("type"),
            "duration": obj.get("duration"),
            "price": obj.get("price"),
            "subscriptionChargeIntervalPriceTiers": IntervalPricingTier.from_dict(obj["subscriptionChargeIntervalPriceTiers"]) if obj.get("subscriptionChargeIntervalPriceTiers") is not None else None
        })
        return _obj


