# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class IntervalPricingTier(BaseModel):
    """
    IntervalPricingTier
    """ # noqa: E501
    tier: Optional[StrictInt] = Field(default=None, description="Unique number of the tier. ")
    starting_unit: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Decimal defining start of tier range. ", alias="startingUnit")
    ending_unit: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Decimal defining end of tier range. ", alias="endingUnit")
    price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The decimal value of the tiered charge model. If the charge model is not a tiered type then this price field will be null and the `price` field directly under the `productRatePlanCharges` applies. ")
    price_format: Optional[StrictStr] = Field(default=None, description="Tier price format. Allowed values: `flat fee`, `per unit`. ", alias="priceFormat")
    is_overage_price: Optional[StrictBool] = Field(default=None, alias="isOveragePrice")
    __properties: ClassVar[List[str]] = ["tier", "startingUnit", "endingUnit", "price", "priceFormat", "isOveragePrice"]

    @field_validator('price_format')
    def price_format_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['FlatFee', 'PerUnit']):
            raise ValueError("must be one of enum values ('FlatFee', 'PerUnit')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IntervalPricingTier from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IntervalPricingTier from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tier": obj.get("tier"),
            "startingUnit": obj.get("startingUnit"),
            "endingUnit": obj.get("endingUnit"),
            "price": obj.get("price"),
            "priceFormat": obj.get("priceFormat"),
            "isOveragePrice": obj.get("isOveragePrice")
        })
        return _obj


