# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.data_backfill_job_status import DataBackfillJobStatus
from zuora_sdk.models.job_type import JobType
from typing import Optional, Set
from typing_extensions import Self

class Job(BaseModel):
    """
    Job
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="Job id")
    import_type: Optional[JobType] = Field(default=None, alias="importType")
    uploaded_file_id: Optional[StrictStr] = Field(default=None, description="Id of uploaded file", alias="uploadedFileId")
    uploaded_file_name: Optional[StrictStr] = Field(default=None, description="Name of uploaded file", alias="uploadedFileName")
    uploaded_file_url: Optional[StrictStr] = Field(default=None, alias="uploadedFileUrl")
    uploaded_file_size: Optional[StrictStr] = Field(default=None, alias="uploadedFileSize")
    input_file_size: Optional[StrictInt] = Field(default=None, alias="inputFileSize")
    output_size: Optional[StrictStr] = Field(default=None, alias="outputSize")
    output_type: Optional[StrictStr] = Field(default=None, alias="outputType")
    output_file_size: Optional[StrictInt] = Field(default=None, alias="outputFileSize")
    uploaded_by: Optional[StrictStr] = Field(default=None, alias="uploadedBy")
    uploaded_on: Optional[datetime] = Field(default=None, alias="uploadedOn")
    completed_on: Optional[datetime] = Field(default=None, alias="completedOn")
    started_processing_on: Optional[datetime] = Field(default=None, alias="startedProcessingOn")
    result_file_id: Optional[StrictStr] = Field(default=None, alias="resultFileId")
    result_file_name: Optional[StrictStr] = Field(default=None, alias="resultFileName")
    result_file_url: Optional[StrictStr] = Field(default=None, alias="resultFileUrl")
    total_count: Optional[StrictInt] = Field(default=None, alias="totalCount")
    failed_count: Optional[StrictInt] = Field(default=None, alias="failedCount")
    status: Optional[DataBackfillJobStatus] = None
    failure_message: Optional[StrictStr] = Field(default=None, alias="failureMessage")
    processed_count: Optional[StrictInt] = Field(default=None, alias="processedCount")
    success_count: Optional[StrictInt] = Field(default=None, alias="successCount")
    remaining_time: Optional[StrictInt] = Field(default=None, alias="remainingTime")
    remaining_time_text: Optional[StrictStr] = Field(default=None, alias="remainingTimeText")
    completed_percentage: Optional[StrictInt] = Field(default=None, alias="completedPercentage")
    __properties: ClassVar[List[str]] = ["id", "importType", "uploadedFileId", "uploadedFileName", "uploadedFileUrl", "uploadedFileSize", "inputFileSize", "outputSize", "outputType", "outputFileSize", "uploadedBy", "uploadedOn", "completedOn", "startedProcessingOn", "resultFileId", "resultFileName", "resultFileUrl", "totalCount", "failedCount", "status", "failureMessage", "processedCount", "successCount", "remainingTime", "remainingTimeText", "completedPercentage"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Job from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Job from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "importType": obj.get("importType"),
            "uploadedFileId": obj.get("uploadedFileId"),
            "uploadedFileName": obj.get("uploadedFileName"),
            "uploadedFileUrl": obj.get("uploadedFileUrl"),
            "uploadedFileSize": obj.get("uploadedFileSize"),
            "inputFileSize": obj.get("inputFileSize"),
            "outputSize": obj.get("outputSize"),
            "outputType": obj.get("outputType"),
            "outputFileSize": obj.get("outputFileSize"),
            "uploadedBy": obj.get("uploadedBy"),
            "uploadedOn": obj.get("uploadedOn"),
            "completedOn": obj.get("completedOn"),
            "startedProcessingOn": obj.get("startedProcessingOn"),
            "resultFileId": obj.get("resultFileId"),
            "resultFileName": obj.get("resultFileName"),
            "resultFileUrl": obj.get("resultFileUrl"),
            "totalCount": obj.get("totalCount"),
            "failedCount": obj.get("failedCount"),
            "status": obj.get("status"),
            "failureMessage": obj.get("failureMessage"),
            "processedCount": obj.get("processedCount"),
            "successCount": obj.get("successCount"),
            "remainingTime": obj.get("remainingTime"),
            "remainingTimeText": obj.get("remainingTimeText"),
            "completedPercentage": obj.get("completedPercentage")
        })
        return _obj


