# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.migration_component_content import MigrationComponentContent
from typing import Optional, Set
from typing_extensions import Self

class MigrationClientResponse(BaseModel):
    """
    Response after migration is added.
    """ # noqa: E501
    email_ids: Optional[StrictStr] = Field(default=None, description="List of Emails with comma separator ", alias="emailIds")
    environment: Optional[StrictStr] = Field(default=None, description="Environment information")
    id: StrictStr = Field(description="Variable to hold the job ID.")
    migrated_by: StrictStr = Field(description="User responsible for migration.", alias="migratedBy")
    migration_description: StrictStr = Field(description="Description of the migration.", alias="migrationDescription")
    migration_end: StrictStr = Field(description="Timestamp when migration ended.", alias="migrationEnd")
    migration_name: StrictStr = Field(description="Name of the migration.", alias="migrationName")
    migration_start: StrictStr = Field(description="Timestamp when migration started.", alias="migrationStart")
    response: Optional[List[MigrationComponentContent]] = None
    source_tenant_description: StrictStr = Field(description="Source Tenant Description.", alias="sourceTenantDescription")
    source_tenant_name: StrictStr = Field(description="Source Tenant Name.", alias="sourceTenantName")
    status: StrictStr = Field(description="Status of the Migration Job.")
    type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["emailIds", "environment", "id", "migratedBy", "migrationDescription", "migrationEnd", "migrationName", "migrationStart", "response", "sourceTenantDescription", "sourceTenantName", "status", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MigrationClientResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in response (list)
        _items = []
        if self.response:
            for _item in self.response:
                if _item:
                    _items.append(_item.to_dict())
            _dict['response'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MigrationClientResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "emailIds": obj.get("emailIds"),
            "environment": obj.get("environment"),
            "id": obj.get("id"),
            "migratedBy": obj.get("migratedBy"),
            "migrationDescription": obj.get("migrationDescription"),
            "migrationEnd": obj.get("migrationEnd"),
            "migrationName": obj.get("migrationName"),
            "migrationStart": obj.get("migrationStart"),
            "response": [MigrationComponentContent.from_dict(_item) for _item in obj["response"]] if obj.get("response") is not None else None,
            "sourceTenantDescription": obj.get("sourceTenantDescription"),
            "sourceTenantName": obj.get("sourceTenantName"),
            "status": obj.get("status"),
            "type": obj.get("type")
        })
        return _obj


