# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class MigrationComponentContent(BaseModel):
    """
    When a comparison is made between a source and target tenant, it sends a response to the user interface.
    """ # noqa: E501
    attribute: Optional[StrictStr] = None
    component_type: Optional[StrictStr] = Field(default=None, description="Type of selected components to be migrated.", alias="componentType")
    current_target_response: Optional[Dict[str, Any]] = Field(default=None, description="Json node object contains metadata.", alias="currentTargetResponse")
    description: Optional[StrictStr] = None
    disabled: Optional[StrictStr] = None
    error_message: Optional[StrictStr] = Field(default=None, description="Error information.", alias="errorMessage")
    http_methods: Optional[StrictStr] = Field(default=None, alias="httpMethods")
    id: Optional[StrictStr] = None
    key: Optional[StrictStr] = None
    migrated_on: Optional[datetime] = Field(default=None, description="It is the time when migration is triggered.", alias="migratedOn")
    migration_id: Optional[StrictStr] = Field(default=None, description="Migration ID. It is generated at the time of triggering deployment.", alias="migrationId")
    path_pattern: Optional[StrictStr] = Field(default=None, description="PathPattern of component.", alias="pathPattern")
    previous_target_response: Optional[Dict[str, Any]] = Field(default=None, description="Json node object contains metadata.", alias="previousTargetResponse")
    result: Optional[StrictStr] = Field(default=None, description="Returns the result details of Components.")
    segregation_key: Optional[StrictStr] = Field(default=None, description="Displays the differences between components.", alias="segregationKey")
    source_response: Optional[Dict[str, Any]] = Field(default=None, description="Json node object contains metadata.", alias="sourceResponse")
    status: Optional[StrictStr] = Field(default=None, description="Returns the status of each component.")
    update_status: Optional[StrictStr] = Field(default=None, description="Updated Status.", alias="updateStatus")
    __properties: ClassVar[List[str]] = ["attribute", "componentType", "currentTargetResponse", "description", "disabled", "errorMessage", "httpMethods", "id", "key", "migratedOn", "migrationId", "pathPattern", "previousTargetResponse", "result", "segregationKey", "sourceResponse", "status", "updateStatus"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MigrationComponentContent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MigrationComponentContent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "attribute": obj.get("attribute"),
            "componentType": obj.get("componentType"),
            "currentTargetResponse": obj.get("currentTargetResponse"),
            "description": obj.get("description"),
            "disabled": obj.get("disabled"),
            "errorMessage": obj.get("errorMessage"),
            "httpMethods": obj.get("httpMethods"),
            "id": obj.get("id"),
            "key": obj.get("key"),
            "migratedOn": obj.get("migratedOn"),
            "migrationId": obj.get("migrationId"),
            "pathPattern": obj.get("pathPattern"),
            "previousTargetResponse": obj.get("previousTargetResponse"),
            "result": obj.get("result"),
            "segregationKey": obj.get("segregationKey"),
            "sourceResponse": obj.get("sourceResponse"),
            "status": obj.get("status"),
            "updateStatus": obj.get("updateStatus")
        })
        return _obj


