# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.open_payment_method_type_response_fields import OpenPaymentMethodTypeResponseFields
from typing import Optional, Set
from typing_extensions import Self

class OpenPaymentMethodTypeResponse(BaseModel):
    """
    OpenPaymentMethodTypeResponse
    """ # noqa: E501
    entity_id: Optional[StrictStr] = Field(default=None, description="If an entity UUID is provided, this custom payment method type is specific to this entity only. If no entity UUID is provided, the custom payment method type is available to the global entity and all the sub entities in the tenant. ", alias="entityId")
    fields: Optional[List[OpenPaymentMethodTypeResponseFields]] = Field(default=None, description="An array containing field metadata of the custom payment method type. ")
    internal_name: Optional[StrictStr] = Field(default=None, description="A string to identify the custom payment method type in the API name of the payment method type.  This field is used along with the `tenantId` field by the system to construct and generate the API name of the custom payment method type in the following way:  `<internalName>__c_<tenantId>`  For example, if `internalName` is `AmazonPay`, and `tenantId` is `12368`, the API name of the custom payment method type will be `AmazonPay__c_12368`. ", alias="internalName")
    label: Optional[StrictStr] = Field(default=None, description="The label that is used to refer to this type in the Zuora UI. ")
    method_reference_id_field: Optional[StrictStr] = Field(default=None, description="The identification reference of the custom payment method.  This field should be mapped to a field name defined in the `fields` array for the purpose of being used as a filter in reporting tools such as Data Source Exports and Data Query. ", alias="methodReferenceIdField")
    revision: Optional[StrictInt] = Field(default=None, description="The revision number of the custom payment method type, which starts from 1 and increases by 1 when you update a published revision for the first time. ")
    status: Optional[StrictStr] = Field(default=None, description="The status of the custom payment method type. ")
    sub_type_field: Optional[StrictStr] = Field(default=None, description="The identification reference indicating the subtype of the custom payment method.  This field should be mapped to a field name defined in the `fields` array for the purpose of being used as a filter in reporting tools such as Data Source Exports and Data Query. ", alias="subTypeField")
    tenant_id: Optional[StrictStr] = Field(default=None, description="Zuora tenant ID. If multi-entity is enabled in your tenant, this is the ID of the parent tenant of all the sub entities. ", alias="tenantId")
    user_reference_id_field: Optional[StrictStr] = Field(default=None, description="The identification reference of the user or customer account.  This field should be mapped to a field name defined in the `fields` array for the purpose of being used as a filter in reporting tools such as Data Source Exports and Data Query. ", alias="userReferenceIdField")
    version: Optional[StrictStr] = Field(default=None, description="The time when the custom payment method type was first published. ")
    __properties: ClassVar[List[str]] = ["entityId", "fields", "internalName", "label", "methodReferenceIdField", "revision", "status", "subTypeField", "tenantId", "userReferenceIdField", "version"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OpenPaymentMethodTypeResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in fields (list)
        _items = []
        if self.fields:
            for _item in self.fields:
                if _item:
                    _items.append(_item.to_dict())
            _dict['fields'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OpenPaymentMethodTypeResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "entityId": obj.get("entityId"),
            "fields": [OpenPaymentMethodTypeResponseFields.from_dict(_item) for _item in obj["fields"]] if obj.get("fields") is not None else None,
            "internalName": obj.get("internalName"),
            "label": obj.get("label"),
            "methodReferenceIdField": obj.get("methodReferenceIdField"),
            "revision": obj.get("revision"),
            "status": obj.get("status"),
            "subTypeField": obj.get("subTypeField"),
            "tenantId": obj.get("tenantId"),
            "userReferenceIdField": obj.get("userReferenceIdField"),
            "version": obj.get("version")
        })
        return _obj


