# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class OpenPaymentMethodTypeResponseFields(BaseModel):
    """
    OpenPaymentMethodTypeResponseFields
    """ # noqa: E501
    checksum: Optional[StrictBool] = Field(default=None, description="The checksum value of a payment method is used to identify if this payment method is the same as another one, or if this payment method is altered to another new payment method.  For example, if you select the credit card number and expiration date as the checksum fields for the CreditCard payment method type, when you modified the expiration date, Zuora considers this payment method as a different payment method compared to the original one. ")
    default_value: Optional[StrictStr] = Field(default=None, description="The default value of the field. ", alias="defaultValue")
    description: Optional[StrictStr] = Field(default=None, description="An explanation of this field. ")
    editable: Optional[StrictBool] = Field(default=None, description="Specify `true` if this field can be updated through PUT API or UI.  Note: If `editable` is set to `false`, you can specify the value of this field in the UI and POST API when creating a payment method. However, after you created the payment method, you cannot edit this field through PUT API or UI. ")
    index: Optional[StrictInt] = Field(default=None, description="The order of the field in this type, starting from 1. ")
    label: Optional[StrictStr] = Field(default=None, description="The label that is used to refer to this field in the Zuora UI. ")
    max_length: Optional[StrictInt] = Field(default=None, description="A maximum length limitation of the field value. ", alias="maxLength")
    min_length: Optional[StrictInt] = Field(default=None, description="A minimal length limitation of the field value. ", alias="minLength")
    name: Optional[StrictStr] = Field(default=None, description="The API name of this field. It must be uinique. ")
    representer: Optional[StrictBool] = Field(default=None, description="This flag determines whether this field will be used for identifying this payment method in the Zuora UI. The field will be shown in the Payment Method field in the UI. ")
    required: Optional[StrictBool] = Field(default=None, description="Specify whether this field is required. ")
    type: Optional[StrictStr] = None
    visible: Optional[StrictBool] = Field(default=None, description="Specify `true` if this field can be retrieved through GET API or UI for displaying payment method details.  Notes:    - If `visible` is set to `false`, you can still specify the value of this field in the UI and POST API when creating the payment method.   - If `visible` is set to `false` and `editable` is set to `true`, this field is not accessible through GET API or UI for displaying details, but you can still see it and edit the value in the UI and PUT API when updating this payment method. ")
    __properties: ClassVar[List[str]] = ["checksum", "defaultValue", "description", "editable", "index", "label", "maxLength", "minLength", "name", "representer", "required", "type", "visible"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OpenPaymentMethodTypeResponseFields from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OpenPaymentMethodTypeResponseFields from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "checksum": obj.get("checksum"),
            "defaultValue": obj.get("defaultValue"),
            "description": obj.get("description"),
            "editable": obj.get("editable"),
            "index": obj.get("index"),
            "label": obj.get("label"),
            "maxLength": obj.get("maxLength"),
            "minLength": obj.get("minLength"),
            "name": obj.get("name"),
            "representer": obj.get("representer"),
            "required": obj.get("required"),
            "type": obj.get("type"),
            "visible": obj.get("visible")
        })
        return _obj


