# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class OrderDeltaMetric(BaseModel):
    """
    OrderDeltaMetric
    """ # noqa: E501
    charge_number: Optional[StrictStr] = Field(default=None, description="The charge number for the associated Rate Plan Charge. This field can be null if the metric is generated for an Order Line Item. ", alias="chargeNumber")
    currency: Optional[StrictStr] = Field(default=None, description="ISO 3-letter currency code (uppercase). For example, USD. ")
    end_date: Optional[date] = Field(default=None, description="The end date for the order delta metric. ", alias="endDate")
    gross_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The gross amount for the metric. The is the amount excluding applied discount. ", alias="grossAmount")
    net_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The net amount for the metric. The is the amount with discounts applied ", alias="netAmount")
    order_action_id: Optional[StrictStr] = Field(default=None, description="The Id for the related Order Action. This field can be null if the metric is generated for an Order Line Item. ", alias="orderActionId")
    order_action_sequence: Optional[StrictStr] = Field(default=None, description="The sequence for the related Order Action. This field can be null if the metric is generated for an Order Line Item. ", alias="orderActionSequence")
    order_action_type: Optional[StrictStr] = Field(default=None, description="The type for the related Order Action. This field can be null if the metric is generated for an Order Line Item. ", alias="orderActionType")
    order_line_item_number: Optional[StrictStr] = Field(default=None, description="A sequential number auto-assigned for each of order line items in a order, used as an index, for example, \"1\". ", alias="orderLineItemNumber")
    product_rate_plan_charge_id: Optional[StrictStr] = Field(default=None, description="The Id for the associated Product Rate Plan Charge. This field can be null if the Order Line Item is not associated with a Product Rate Plan Charge.", alias="productRatePlanChargeId")
    rate_plan_charge_id: Optional[StrictStr] = Field(default=None, description="The id for the associated Rate Plan Charge. This field can be null if the metric is generated for an Order Line Item. ", alias="ratePlanChargeId")
    start_date: Optional[date] = Field(default=None, description="The start date for the order delta metric. ", alias="startDate")
    subscription_number: Optional[StrictStr] = Field(default=None, description="The number of the subscription. This field can be null if the metric is generated for an Order Line Item. ", alias="subscriptionNumber")
    __properties: ClassVar[List[str]] = ["chargeNumber", "currency", "endDate", "grossAmount", "netAmount", "orderActionId", "orderActionSequence", "orderActionType", "orderLineItemNumber", "productRatePlanChargeId", "ratePlanChargeId", "startDate", "subscriptionNumber"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrderDeltaMetric from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrderDeltaMetric from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "chargeNumber": obj.get("chargeNumber"),
            "currency": obj.get("currency"),
            "endDate": obj.get("endDate"),
            "grossAmount": obj.get("grossAmount"),
            "netAmount": obj.get("netAmount"),
            "orderActionId": obj.get("orderActionId"),
            "orderActionSequence": obj.get("orderActionSequence"),
            "orderActionType": obj.get("orderActionType"),
            "orderLineItemNumber": obj.get("orderLineItemNumber"),
            "productRatePlanChargeId": obj.get("productRatePlanChargeId"),
            "ratePlanChargeId": obj.get("ratePlanChargeId"),
            "startDate": obj.get("startDate"),
            "subscriptionNumber": obj.get("subscriptionNumber")
        })
        return _obj


