# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PaymentMethodResponseACH(BaseModel):
    """
    PaymentMethodResponseACH
    """ # noqa: E501
    bank_aba_code: Optional[StrictStr] = Field(default=None, description="The nine-digit routing number or ABA number used by banks. This field is only required if the `type` field is set to `ACH`. ", alias="bankABACode")
    bank_account_name: Optional[StrictStr] = Field(default=None, description="The name of the account holder, which can be either a person or a company. This field is only required if the `type` field is set to `ACH`. ", alias="bankAccountName")
    bank_account_number: Optional[StrictStr] = Field(default=None, description="The bank account number associated with the ACH payment. This field is only required if the `type` field is set to `ACH`. However, for creating tokenized ACH payment methods on  Stripe v2, this field is optional if the `tokens` and `bankAccountMaskNumber` fields are specified. ", alias="bankAccountNumber")
    bank_account_mask_number: Optional[StrictStr] = Field(default=None, description="The masked bank account number associated with the ACH payment. This field is only required if the ACH payment method is created using tokens. ", alias="bankAccountMaskNumber")
    bank_account_type: Optional[StrictStr] = Field(default=None, alias="bankAccountType")
    bank_name: Optional[StrictStr] = Field(default=None, description="The name of the bank where the ACH payment account is held. This field is only required if the `type` field is set to `ACH`.  When creating an ACH payment method on Adyen, this field is required by Zuora but it is not required by Adyen. To create the ACH payment method successfully, specify a real value for this field if you can. If it is not possible to get the real value for it, specify a dummy value. ", alias="bankName")
    __properties: ClassVar[List[str]] = ["bankABACode", "bankAccountName", "bankAccountNumber", "bankAccountMaskNumber", "bankAccountType", "bankName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PaymentMethodResponseACH from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PaymentMethodResponseACH from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bankABACode": obj.get("bankABACode"),
            "bankAccountName": obj.get("bankAccountName"),
            "bankAccountNumber": obj.get("bankAccountNumber"),
            "bankAccountMaskNumber": obj.get("bankAccountMaskNumber"),
            "bankAccountType": obj.get("bankAccountType"),
            "bankName": obj.get("bankName")
        })
        return _obj


