# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PaymentMethodResponseBankTransfer(BaseModel):
    """
    PaymentMethodResponseBankTransfer
    """ # noqa: E501
    iban: Optional[StrictStr] = Field(default=None, description="The International Bank Account Number used to create the SEPA payment method. The value is masked. ", alias="IBAN")
    account_number: Optional[StrictStr] = Field(default=None, description="The number of the customer's bank account and it is masked. ", alias="accountNumber")
    bank_code: Optional[StrictStr] = Field(default=None, description="The sort code or number that identifies the bank. This is also known as the sort code.          ", alias="bankCode")
    bank_transfer_type: Optional[StrictStr] = Field(default=None, description="The type of the Bank Transfer payment method. For example, `SEPA`. ", alias="bankTransferType")
    branch_code: Optional[StrictStr] = Field(default=None, description="The branch code of the bank used for Direct Debit.           ", alias="branchCode")
    business_identification_code: Optional[StrictStr] = Field(default=None, description="The BIC code used for SEPA. The value is masked.        ", alias="businessIdentificationCode")
    identity_number: Optional[StrictStr] = Field(default=None, description="The identity number of the customer. ", alias="identityNumber")
    __properties: ClassVar[List[str]] = ["IBAN", "accountNumber", "bankCode", "bankTransferType", "branchCode", "businessIdentificationCode", "identityNumber"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PaymentMethodResponseBankTransfer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PaymentMethodResponseBankTransfer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "IBAN": obj.get("IBAN"),
            "accountNumber": obj.get("accountNumber"),
            "bankCode": obj.get("bankCode"),
            "bankTransferType": obj.get("bankTransferType"),
            "branchCode": obj.get("branchCode"),
            "businessIdentificationCode": obj.get("businessIdentificationCode"),
            "identityNumber": obj.get("identityNumber")
        })
        return _obj


