# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from decimal import Decimal
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PaymentWithCustomRates(BaseModel):
    """
    PaymentWithCustomRates
    """ # noqa: E501
    currency: StrictStr = Field(description="The currency code for either Reporting or Home currency.  **Note**: This field is only available if you set the `zuora-version` request header to `224.0` or later. ")
    custom_fx_rate: Decimal = Field(description="The Custom FX conversion rate between Home/Reporting and Transactional currency items.  **Note**: This field is only available if you set the `zuora-version` request header to `224.0` or later. ", alias="customFxRate")
    rate_date: Optional[StrictStr] = Field(default=None, description="The date on which a particular currency rate is fixed or obtained on.  **Note**: This field is only available if you set the `zuora-version` request header to `224.0` or later. ", alias="rateDate")
    __properties: ClassVar[List[str]] = ["currency", "customFxRate", "rateDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PaymentWithCustomRates from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PaymentWithCustomRates from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "currency": obj.get("currency"),
            "customFxRate": obj.get("customFxRate"),
            "rateDate": obj.get("rateDate")
        })
        return _obj


