# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.post_custom_object_definition_field_definition_request import PostCustomObjectDefinitionFieldDefinitionRequest
from typing import Optional, Set
from typing_extensions import Self

class PostCustomObjectDefinitionsRequestDefinition(BaseModel):
    """
    PostCustomObjectDefinitionsRequestDefinition
    """ # noqa: E501
    auditable: Optional[List[StrictStr]] = Field(default=None, description="The set of fields which Audit Trail tracks and records changes of. You can change auditable fields to non-auditable, and vice versa. One custom object can have a maximum of five auditable fields.")
    enable_create_record_auditing: Optional[StrictBool] = Field(default=False, description="Indicates whether to audit the creation of custom object records of this custom object definition.  Note that you must enable the **Custom Object Definition** audit trail setting in your Zuora tenant before auditing custom object record creation. For more information, see <a href=\"https://knowledgecenter.zuora.com/Zuora_Central_Platform/Tenant_Management/A_Administrator_Settings/Manage_Audit_Trail_Settings\" target=\"_blank\">Manage audit trail settings</a>. ", alias="enableCreateRecordAuditing")
    enable_delete_record_auditing: Optional[StrictBool] = Field(default=False, description="Indicates whether to audit the deletion of custom object records of this custom object definition.  Note that you must enable the **Custom Object Definition** audit trail setting in your Zuora tenant before auditing custom object record deletion. For more information, see <a href=\"https://knowledgecenter.zuora.com/Zuora_Central_Platform/Tenant_Management/A_Administrator_Settings/Manage_Audit_Trail_Settings\" target=\"_blank\">Manage audit trail settings</a>. ", alias="enableDeleteRecordAuditing")
    filterable: Optional[List[StrictStr]] = Field(default=None, description="The set of fields that are allowed to be queried on. Queries on non-filterable fields will be rejected. You can not change a non-filterable field to filterable.")
    label: StrictStr = Field(description="A UI label for the custom object")
    object: StrictStr = Field(description="The API name of the custom object")
    properties: Optional[Dict[str, PostCustomObjectDefinitionFieldDefinitionRequest]] = None
    relationships: Optional[List[Dict[str, Any]]] = Field(default=None, description="An array of relationships with Zuora objects or other custom objects. You can add at most 2 `manyToOne` relationships when creating a custom field definition.")
    required: Optional[List[StrictStr]] = Field(default=None, description="The required fields of the custom object. You can change required fields to optional. However, you can only change optional fields to required on the custom objects with no records.")
    unique: Optional[List[StrictStr]] = Field(default=None, description="The fields with unique constraints. You can remove the unique constraint on a field. However, you can only add a unique constraint to a filterable field if the custom object contains no record. One custom object can have a maximum of five fields with unique constraints.")
    __properties: ClassVar[List[str]] = ["auditable", "enableCreateRecordAuditing", "enableDeleteRecordAuditing", "filterable", "label", "object", "properties", "relationships", "required", "unique"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostCustomObjectDefinitionsRequestDefinition from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in properties (dict)
        _field_dict = {}
        if self.properties:
            for _key in self.properties:
                if self.properties[_key]:
                    _field_dict[_key] = self.properties[_key].to_dict()
            _dict['properties'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostCustomObjectDefinitionsRequestDefinition from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "auditable": obj.get("auditable"),
            "enableCreateRecordAuditing": obj.get("enableCreateRecordAuditing") if obj.get("enableCreateRecordAuditing") is not None else False,
            "enableDeleteRecordAuditing": obj.get("enableDeleteRecordAuditing") if obj.get("enableDeleteRecordAuditing") is not None else False,
            "filterable": obj.get("filterable"),
            "label": obj.get("label"),
            "object": obj.get("object"),
            "properties": dict(
                (_k, PostCustomObjectDefinitionFieldDefinitionRequest.from_dict(_v))
                for _k, _v in obj["properties"].items()
            )
            if obj.get("properties") is not None
            else None,
            "relationships": obj.get("relationships"),
            "required": obj.get("required"),
            "unique": obj.get("unique")
        })
        return _obj


