# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class PostPublicEmailTemplateRequest(BaseModel):
    """
    PostPublicEmailTemplateRequest
    """ # noqa: E501
    active: Optional[StrictBool] = Field(default=True, description="The status of the email template. The default value is `true`.")
    bcc_email_address: Optional[StrictStr] = Field(default=None, description="The email bcc address.", alias="bccEmailAddress")
    cc_email_address: Optional[StrictStr] = Field(default=None, description="The email CC address.", alias="ccEmailAddress")
    cc_email_type: Optional[StrictStr] = Field(default=None, alias="ccEmailType")
    description: Optional[Annotated[str, Field(strict=True, max_length=255)]] = Field(default=None, description="The description of the email template.")
    email_body: StrictStr = Field(description="The email body. You can add merge fields in the email object using angle brackets.  You can also embed HTML tags if `isHtml` is `true`.", alias="emailBody")
    email_subject: StrictStr = Field(description="The email subject. Users can add merge fields in the email subject using angle brackets.", alias="emailSubject")
    encoding_type: Optional[StrictStr] = Field(default=None, alias="encodingType")
    event_category: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="If you specify this field, the email template is created based on a standard event. See [Standard Event Categories](https://knowledgecenter.zuora.com/Central_Platform/Notifications/A_Standard_Events/Standard_Event_Category_Code_for_Notification_Histories_API) for all standard event category codes.  ", alias="eventCategory")
    event_type_name: Optional[StrictStr] = Field(default=None, description="The name of the custom event or custom scheduled event. If you specify this field, the email template is created based on the corresponding custom event or custom scheduled event. ", alias="eventTypeName")
    event_type_namespace: Optional[StrictStr] = Field(default=None, description="The namespace of the `eventTypeName` field. The `eventTypeName` has the `user.notification` namespace by default.   Note that if the `eventTypeName` is a standard event type, you must specify the `com.zuora.notification` namespace; otherwise, you will get an error.  For example, if you want to create an email template on the `OrderActionProcessed` event, you must specify `com.zuora.notification` for this field.          ", alias="eventTypeNamespace")
    from_email_address: Optional[StrictStr] = Field(default=None, description="If fromEmailType is SpecificEmail, this field is required.", alias="fromEmailAddress")
    from_email_type: StrictStr = Field(alias="fromEmailType")
    from_name: Optional[StrictStr] = Field(default=None, description="The name of the email sender.", alias="fromName")
    is_html: Optional[StrictBool] = Field(default=False, description="Indicates whether the style of email body is HTML. The default value is `false`.", alias="isHtml")
    name: Annotated[str, Field(strict=True, max_length=255)] = Field(description="The name of the email template, a unique name in a tenant.")
    reply_to_email_address: Optional[StrictStr] = Field(default=None, description="If replyToEmailType is SpecificEmail, this field is required.", alias="replyToEmailAddress")
    reply_to_email_type: Optional[StrictStr] = Field(default=None, alias="replyToEmailType")
    to_email_address: Optional[StrictStr] = Field(default=None, description="If toEmailType is SpecificEmail, this field is required.", alias="toEmailAddress")
    to_email_type: StrictStr = Field(alias="toEmailType")
    __properties: ClassVar[List[str]] = ["active", "bccEmailAddress", "ccEmailAddress", "ccEmailType", "description", "emailBody", "emailSubject", "encodingType", "eventCategory", "eventTypeName", "eventTypeNamespace", "fromEmailAddress", "fromEmailType", "fromName", "isHtml", "name", "replyToEmailAddress", "replyToEmailType", "toEmailAddress", "toEmailType"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostPublicEmailTemplateRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostPublicEmailTemplateRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "active": obj.get("active") if obj.get("active") is not None else True,
            "bccEmailAddress": obj.get("bccEmailAddress"),
            "ccEmailAddress": obj.get("ccEmailAddress"),
            "ccEmailType": obj.get("ccEmailType"),
            "description": obj.get("description"),
            "emailBody": obj.get("emailBody"),
            "emailSubject": obj.get("emailSubject"),
            "encodingType": obj.get("encodingType"),
            "eventCategory": obj.get("eventCategory"),
            "eventTypeName": obj.get("eventTypeName"),
            "eventTypeNamespace": obj.get("eventTypeNamespace"),
            "fromEmailAddress": obj.get("fromEmailAddress"),
            "fromEmailType": obj.get("fromEmailType"),
            "fromName": obj.get("fromName"),
            "isHtml": obj.get("isHtml") if obj.get("isHtml") is not None else False,
            "name": obj.get("name"),
            "replyToEmailAddress": obj.get("replyToEmailAddress"),
            "replyToEmailType": obj.get("replyToEmailType"),
            "toEmailAddress": obj.get("toEmailAddress"),
            "toEmailType": obj.get("toEmailType")
        })
        return _obj


