# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.preview_charge_metrics_cmrr import PreviewChargeMetricsCmrr
from zuora_sdk.models.preview_charge_metrics_tax import PreviewChargeMetricsTax
from zuora_sdk.models.preview_charge_metrics_tcb import PreviewChargeMetricsTcb
from zuora_sdk.models.preview_charge_metrics_tcv import PreviewChargeMetricsTcv
from typing import Optional, Set
from typing_extensions import Self

class PreviewChargeMetrics(BaseModel):
    """
    PreviewChargeMetrics
    """ # noqa: E501
    charge_number: Optional[StrictStr] = Field(default=None, alias="chargeNumber")
    cmrr: Optional[PreviewChargeMetricsCmrr] = None
    origin_rate_plan_id: Optional[StrictStr] = Field(default=None, alias="originRatePlanId")
    product_rate_plan_charge_id: Optional[StrictStr] = Field(default=None, alias="productRatePlanChargeId")
    product_rate_plan_id: Optional[StrictStr] = Field(default=None, alias="productRatePlanId")
    subscription_rate_plan_number: Optional[StrictStr] = Field(default=None, alias="subscriptionRatePlanNumber")
    tax: Optional[PreviewChargeMetricsTax] = None
    tcb: Optional[PreviewChargeMetricsTcb] = None
    tcv: Optional[PreviewChargeMetricsTcv] = None
    __properties: ClassVar[List[str]] = ["chargeNumber", "cmrr", "originRatePlanId", "productRatePlanChargeId", "productRatePlanId", "subscriptionRatePlanNumber", "tax", "tcb", "tcv"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PreviewChargeMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of cmrr
        if self.cmrr:
            _dict['cmrr'] = self.cmrr.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tax
        if self.tax:
            _dict['tax'] = self.tax.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tcb
        if self.tcb:
            _dict['tcb'] = self.tcb.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tcv
        if self.tcv:
            _dict['tcv'] = self.tcv.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PreviewChargeMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "chargeNumber": obj.get("chargeNumber"),
            "cmrr": PreviewChargeMetricsCmrr.from_dict(obj["cmrr"]) if obj.get("cmrr") is not None else None,
            "originRatePlanId": obj.get("originRatePlanId"),
            "productRatePlanChargeId": obj.get("productRatePlanChargeId"),
            "productRatePlanId": obj.get("productRatePlanId"),
            "subscriptionRatePlanNumber": obj.get("subscriptionRatePlanNumber"),
            "tax": PreviewChargeMetricsTax.from_dict(obj["tax"]) if obj.get("tax") is not None else None,
            "tcb": PreviewChargeMetricsTcb.from_dict(obj["tcb"]) if obj.get("tcb") is not None else None,
            "tcv": PreviewChargeMetricsTcv.from_dict(obj["tcv"]) if obj.get("tcv") is not None else None
        })
        return _obj


