# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from zuora_sdk.models.preview_existing_subscription_discount_details import PreviewExistingSubscriptionDiscountDetails
from typing import Optional, Set
from typing_extensions import Self

class PreviewExistingSubscriptionInvoiceItemResult(BaseModel):
    """
    PreviewExistingSubscriptionInvoiceItemResult
    """ # noqa: E501
    service_start_date: Optional[date] = Field(default=None, description="Service start date as yyyy-mm-dd. If the charge is a one-time fee, this is the date of that charge.", alias="serviceStartDate")
    service_end_date: Optional[date] = Field(default=None, description="End date of the service period for this item, i.e., the last day of the period, as yyyy-mm-dd.", alias="serviceEndDate")
    amount_without_tax: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Invoice amount minus tax.", alias="amountWithoutTax")
    tax_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The tax amount of the invoice item.", alias="taxAmount")
    charge_description: Optional[StrictStr] = Field(default=None, description="Description of the charge.", alias="chargeDescription")
    charge_name: Optional[StrictStr] = Field(default=None, description="Name of the charge.", alias="chargeName")
    charge_number: Optional[StrictStr] = Field(default=None, description="Available when the chargeNumber was specified in the request or when the order is amending an existing subscription.", alias="chargeNumber")
    product_name: Optional[StrictStr] = Field(default=None, description="Name of the product.", alias="productName")
    product_rate_plan_charge_id: Optional[StrictStr] = Field(default=None, description="The ID of the product rate plan charge.", alias="productRatePlanChargeId")
    processing_type: Optional[StrictStr] = Field(default=None, alias="processingType")
    unit_price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The unit price of the charge.", alias="unitPrice")
    quantity: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The quantity of the charge.")
    unit_of_measure: Optional[StrictStr] = Field(default=None, description="The unit of measure of the charge.", alias="unitOfMeasure")
    discount_details: Optional[List[PreviewExistingSubscriptionDiscountDetails]] = Field(default=None, description="Container for discount details.", alias="discountDetails")
    __properties: ClassVar[List[str]] = ["serviceStartDate", "serviceEndDate", "amountWithoutTax", "taxAmount", "chargeDescription", "chargeName", "chargeNumber", "productName", "productRatePlanChargeId", "processingType", "unitPrice", "quantity", "unitOfMeasure", "discountDetails"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PreviewExistingSubscriptionInvoiceItemResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in discount_details (list)
        _items = []
        if self.discount_details:
            for _item in self.discount_details:
                if _item:
                    _items.append(_item.to_dict())
            _dict['discountDetails'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PreviewExistingSubscriptionInvoiceItemResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "serviceStartDate": obj.get("serviceStartDate"),
            "serviceEndDate": obj.get("serviceEndDate"),
            "amountWithoutTax": obj.get("amountWithoutTax"),
            "taxAmount": obj.get("taxAmount"),
            "chargeDescription": obj.get("chargeDescription"),
            "chargeName": obj.get("chargeName"),
            "chargeNumber": obj.get("chargeNumber"),
            "productName": obj.get("productName"),
            "productRatePlanChargeId": obj.get("productRatePlanChargeId"),
            "processingType": obj.get("processingType"),
            "unitPrice": obj.get("unitPrice"),
            "quantity": obj.get("quantity"),
            "unitOfMeasure": obj.get("unitOfMeasure"),
            "discountDetails": [PreviewExistingSubscriptionDiscountDetails.from_dict(_item) for _item in obj["discountDetails"]] if obj.get("discountDetails") is not None else None
        })
        return _obj


