# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PreviewSubscriptionBillToContact(BaseModel):
    """
    Container for bill-to contact information of this account. 
    """ # noqa: E501
    city: Optional[StrictStr] = Field(default=None, description="The city of the bill-to address. The value should be 40 characters or less. ")
    country: Optional[StrictStr] = Field(default=None, description="The country of the bill-to address. The value must be a valid country name or abbreviation.  **Note:** You must specify this field if you are using Zuora Tax for this account. ")
    county: Optional[StrictStr] = Field(default=None, description="The county of the bill-to address. The value should be 32 characters or less. ")
    state: Optional[StrictStr] = Field(default=None, description="The state of the bill-to address. The value must be a valid state or province name or 2-character abbreviation.  **Note:** You must specify this field if you are using Zuora Tax for this account and the country is `USA` or `Canada`. ")
    tax_region: Optional[StrictStr] = Field(default=None, description="If using Zuora Tax, a region string as optionally defined in your tax rules. ", alias="taxRegion")
    zip_code: Optional[StrictStr] = Field(default=None, description="The zip code of the bill-to address. The value should be 20 characters or less. ", alias="zipCode")
    __properties: ClassVar[List[str]] = ["city", "country", "county", "state", "taxRegion", "zipCode"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PreviewSubscriptionBillToContact from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PreviewSubscriptionBillToContact from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "city": obj.get("city"),
            "country": obj.get("country"),
            "county": obj.get("county"),
            "state": obj.get("state"),
            "taxRegion": obj.get("taxRegion"),
            "zipCode": obj.get("zipCode")
        })
        return _obj


