# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from zuora_sdk.models.price_format_product_rate_plan_charge_tier import PriceFormatProductRatePlanChargeTier
from typing import Optional, Set
from typing_extensions import Self

class ProductRatePlanChargeTier(BaseModel):
    """
    ProductRatePlanChargeTier
    """ # noqa: E501
    currency: Optional[StrictStr] = Field(default=None, description="The code corresponding to the currency for the tier's price. ", alias="Currency")
    discount_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The specific amount for a fixed discount. Required if the charge model of the product rate plan charge is `Discount-Fixed Amount`. ", alias="DiscountAmount")
    discount_percentage: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The percentage of discount for a percentage discount. Required if the charge model of the product rate plan charge is `Discount-Percentage`. ", alias="DiscountPercentage")
    ending_unit: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The end number of a range of units for the tier. Required if the charge model of the product rate plan charge is `Tiered Pricing` or `Tiered with Overage Pricing`. ", alias="EndingUnit")
    is_overage_price: Optional[StrictBool] = Field(default=None, description="Indicates if the price is an overage price, which is the price when usage surpasses the last defined tier. ", alias="IsOveragePrice")
    price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The price of the tier if the charge is a flat fee, or the price of each unit in the tier if the charge model is tiered pricing. ", alias="Price")
    price_format: Optional[PriceFormatProductRatePlanChargeTier] = Field(default=None, alias="PriceFormat")
    starting_unit: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The starting number of a range of units for the tier. Required if the charge model of the product rate plan charge is `Tiered Pricing` or `Tiered with Overage Pricing`. ", alias="StartingUnit")
    __properties: ClassVar[List[str]] = ["Currency", "DiscountAmount", "DiscountPercentage", "EndingUnit", "IsOveragePrice", "Price", "PriceFormat", "StartingUnit"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProductRatePlanChargeTier from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProductRatePlanChargeTier from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "Currency": obj.get("Currency"),
            "DiscountAmount": obj.get("DiscountAmount"),
            "DiscountPercentage": obj.get("DiscountPercentage"),
            "EndingUnit": obj.get("EndingUnit"),
            "IsOveragePrice": obj.get("IsOveragePrice"),
            "Price": obj.get("Price"),
            "PriceFormat": obj.get("PriceFormat"),
            "StartingUnit": obj.get("StartingUnit")
        })
        return _obj


