# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class ProductRatePlanWithExternalId(BaseModel):
    """
    ProductRatePlanWithExternalId
    """ # noqa: E501
    external_id_source_system: Optional[StrictStr] = Field(default=None, description="The combination of `externallyManagedPlanId` and `externalIdSourceSystem` is the unique identifier for the rate plan purchased on a third-party store. This field is used to represent a subscription rate plan created through third-party stores. ", alias="ExternalIdSourceSystem")
    description: Optional[StrictStr] = Field(default=None, description="The short description of the product rate plan. ")
    effective_end_date: Optional[date] = Field(default=None, description="The end date of the product rate plan. ", alias="effectiveEndDate")
    effective_start_date: Optional[date] = Field(default=None, description="The start date of the product rate plan. ", alias="effectiveStartDate")
    externally_managed_plan_ids: Optional[List[StrictStr]] = Field(default=None, description="The unique identifier for the product rate plan in a third-party store. This field is used to represent a rate plan created through third-party stores. ", alias="externallyManagedPlanIds")
    grade: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The grade of the product rate plan.  **Note**: This field is in the **Early Adopter** phase. We are actively soliciting feedback from a small set of early adopters before releasing it as generally available. If you want to join this early adopter program, submit a request at [Zuora Global Support](http://support.zuora.com/). ")
    id: Optional[StrictStr] = Field(default=None, description="The unique product rate plan ID. ")
    name: Optional[StrictStr] = Field(default=None, description="The name of the product rate plan. ")
    status: Optional[StrictStr] = None
    success: Optional[StrictBool] = Field(default=None, description="Returns `true` if the request was processed successfully. ")
    __properties: ClassVar[List[str]] = ["ExternalIdSourceSystem", "description", "effectiveEndDate", "effectiveStartDate", "externallyManagedPlanIds", "grade", "id", "name", "status", "success"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProductRatePlanWithExternalId from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProductRatePlanWithExternalId from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ExternalIdSourceSystem": obj.get("ExternalIdSourceSystem"),
            "description": obj.get("description"),
            "effectiveEndDate": obj.get("effectiveEndDate"),
            "effectiveStartDate": obj.get("effectiveStartDate"),
            "externallyManagedPlanIds": obj.get("externallyManagedPlanIds"),
            "grade": obj.get("grade"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "status": obj.get("status"),
            "success": obj.get("success")
        })
        return _obj


