# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.z_object import ZObject
from typing import Optional, Set
from typing_extensions import Self

class ProxyActionqueryResponse(BaseModel):
    """
    ProxyActionqueryResponse
    """ # noqa: E501
    done: Optional[StrictBool] = Field(default=None, description="Indicates whether the returned records contain all the query results. * If the `queryLocator` field is returned, this field is set to `false`. * If no `queryLocator` field is returned, this field is set to `true`. ")
    query_locator: Optional[StrictStr] = Field(default=None, description="A marker passed to QueryMore to get the next set of results. For more information, see [QueryMore](https://www.zuora.com/developer/api-references/api/operation/Action_PostqueryMore/).", alias="queryLocator")
    records: Optional[List[ZObject]] = Field(default=None, description="A list of queried results.")
    size: Optional[StrictInt] = Field(default=None, description="The number of the returned query results.")
    __properties: ClassVar[List[str]] = ["done", "queryLocator", "records", "size"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProxyActionqueryResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in records (list)
        _items = []
        if self.records:
            for _item in self.records:
                if _item:
                    _items.append(_item.to_dict())
            _dict['records'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProxyActionqueryResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "done": obj.get("done"),
            "queryLocator": obj.get("queryLocator"),
            "records": [ZObject.from_dict(_item) for _item in obj["records"]] if obj.get("records") is not None else None,
            "size": obj.get("size")
        })
        return _obj


