# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class ProxyCreateTaxationItemRequest(BaseModel):
    """
    ProxyCreateTaxationItemRequest
    """ # noqa: E501
    accounting_code: Optional[StrictStr] = Field(default=None, description=" The Chart of Accounts ", alias="AccountingCode")
    exempt_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description=" The calculated tax amount excluded due to the exemption. **Character limit**: 16 **Values**: a decimal value ", alias="ExemptAmount")
    invoice_item_id: StrictStr = Field(description=" The ID of the specific invoice item that the taxation information applies to. **Character limit**: 32 **Values**: a valid invoice item ID ", alias="InvoiceItemId")
    jurisdiction: StrictStr = Field(description=" The jurisdiction that applies the tax or VAT. This value is typically a state, province, county, or city. **Character limit**: 32 **Values**: a string of 32 characterrs or fewer ", alias="Jurisdiction")
    location_code: Optional[StrictStr] = Field(default=None, description=" The identifier for the location based on the value of the `TaxCode` field. **Character limit**: 32 **Values**: automatically generated ", alias="LocationCode")
    name: StrictStr = Field(description=" The name of the tax rate, such as sales tax or GST. This name is displayed on invoices. **Character limit**: 128 **Values**: a string of 128 characters or fewer ", alias="Name")
    tax_amount: Union[StrictFloat, StrictInt] = Field(description=" The amount of the tax applied to the charge. **Character limit**: 16 **Values**: a decimal value ", alias="TaxAmount")
    tax_code: Optional[StrictStr] = Field(default=None, description=" The tax code identifies which tax rules and tax rates to apply to a specific charge. **Character limit**: 32 **Values**: a string of 32 characters or fewer ", alias="TaxCode")
    tax_code_description: Optional[StrictStr] = Field(default=None, description=" The description for the tax code. **Character limit**: 255 **Values**: a string of 255 characters or fewer ", alias="TaxCodeDescription")
    tax_date: date = Field(description=" The date that the tax is applied to the charge, in `yyyy-mm-dd` format. **Character limit**: 29 ", alias="TaxDate")
    tax_rate: Union[StrictFloat, StrictInt] = Field(description=" The tax rate applied to the charge. **Character limit**: 16 **Values**: a valid decimal value ", alias="TaxRate")
    tax_rate_description: Optional[StrictStr] = Field(default=None, description=" The description of the tax rate. **Character limit**: 255 **Values**: a string of 255 characters or fewer ", alias="TaxRateDescription")
    tax_rate_type: StrictStr = Field(description=" The type of the tax rate applied to the charge. **Character limit**: 10 **Values**: `Percentage`, `FlatFee` ", alias="TaxRateType")
    __properties: ClassVar[List[str]] = ["AccountingCode", "ExemptAmount", "InvoiceItemId", "Jurisdiction", "LocationCode", "Name", "TaxAmount", "TaxCode", "TaxCodeDescription", "TaxDate", "TaxRate", "TaxRateDescription", "TaxRateType"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProxyCreateTaxationItemRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProxyCreateTaxationItemRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "AccountingCode": obj.get("AccountingCode"),
            "ExemptAmount": obj.get("ExemptAmount"),
            "InvoiceItemId": obj.get("InvoiceItemId"),
            "Jurisdiction": obj.get("Jurisdiction"),
            "LocationCode": obj.get("LocationCode"),
            "Name": obj.get("Name"),
            "TaxAmount": obj.get("TaxAmount"),
            "TaxCode": obj.get("TaxCode"),
            "TaxCodeDescription": obj.get("TaxCodeDescription"),
            "TaxDate": obj.get("TaxDate"),
            "TaxRate": obj.get("TaxRate"),
            "TaxRateDescription": obj.get("TaxRateDescription"),
            "TaxRateType": obj.get("TaxRateType")
        })
        return _obj


