# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from zuora_sdk.models.ramp_interval_charge_delta_metrics_delta_mrr_inner import RampIntervalChargeDeltaMetricsDeltaMrrInner
from zuora_sdk.models.ramp_interval_charge_delta_metrics_delta_quantity_inner import RampIntervalChargeDeltaMetricsDeltaQuantityInner
from typing import Optional, Set
from typing_extensions import Self

class RampIntervalChargeDeltaMetrics(BaseModel):
    """
    RampIntervalChargeDeltaMetrics
    """ # noqa: E501
    charge_number: Optional[StrictStr] = Field(default=None, description="The number of the rate plan charge.", alias="chargeNumber")
    delta_discount_tcb: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The discount delta amount for the TCB.", alias="deltaDiscountTcb")
    delta_discount_tcv: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The discount delta amount for the TCV.", alias="deltaDiscountTcv")
    delta_gross_tcb: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The TCB delta value before discount charges are applied.", alias="deltaGrossTcb")
    delta_gross_tcv: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The TCV delta value before discount charges are applied.", alias="deltaGrossTcv")
    delta_mrr: Optional[List[RampIntervalChargeDeltaMetricsDeltaMrrInner]] = Field(default=None, description="The MRR changing history of the current rate plan charge in the current ramp interval.", alias="deltaMrr")
    delta_net_tcb: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The TCB delta value after discount charges are applied.", alias="deltaNetTcb")
    delta_net_tcv: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The TCV delta value after discount charges are applied.", alias="deltaNetTcv")
    delta_quantity: Optional[List[RampIntervalChargeDeltaMetricsDeltaQuantityInner]] = Field(default=None, description="The charge quantity changing history of the current rate plan charge in the current ramp interval.", alias="deltaQuantity")
    product_rate_plan_charge_id: Optional[StrictStr] = Field(default=None, description="The ID of the corresponding product rate plan charge.", alias="productRatePlanChargeId")
    subscription_number: Optional[StrictStr] = Field(default=None, description="The number of the subscription that the current rate plan charge belongs to.", alias="subscriptionNumber")
    __properties: ClassVar[List[str]] = ["chargeNumber", "deltaDiscountTcb", "deltaDiscountTcv", "deltaGrossTcb", "deltaGrossTcv", "deltaMrr", "deltaNetTcb", "deltaNetTcv", "deltaQuantity", "productRatePlanChargeId", "subscriptionNumber"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RampIntervalChargeDeltaMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in delta_mrr (list)
        _items = []
        if self.delta_mrr:
            for _item in self.delta_mrr:
                if _item:
                    _items.append(_item.to_dict())
            _dict['deltaMrr'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in delta_quantity (list)
        _items = []
        if self.delta_quantity:
            for _item in self.delta_quantity:
                if _item:
                    _items.append(_item.to_dict())
            _dict['deltaQuantity'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RampIntervalChargeDeltaMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "chargeNumber": obj.get("chargeNumber"),
            "deltaDiscountTcb": obj.get("deltaDiscountTcb"),
            "deltaDiscountTcv": obj.get("deltaDiscountTcv"),
            "deltaGrossTcb": obj.get("deltaGrossTcb"),
            "deltaGrossTcv": obj.get("deltaGrossTcv"),
            "deltaMrr": [RampIntervalChargeDeltaMetricsDeltaMrrInner.from_dict(_item) for _item in obj["deltaMrr"]] if obj.get("deltaMrr") is not None else None,
            "deltaNetTcb": obj.get("deltaNetTcb"),
            "deltaNetTcv": obj.get("deltaNetTcv"),
            "deltaQuantity": [RampIntervalChargeDeltaMetricsDeltaQuantityInner.from_dict(_item) for _item in obj["deltaQuantity"]] if obj.get("deltaQuantity") is not None else None,
            "productRatePlanChargeId": obj.get("productRatePlanChargeId"),
            "subscriptionNumber": obj.get("subscriptionNumber")
        })
        return _obj


