# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.ramp_charge_response import RampChargeResponse
from zuora_sdk.models.ramp_interval_response import RampIntervalResponse
from typing import Optional, Set
from typing_extensions import Self

class RampResponse(BaseModel):
    """
    RampResponse
    """ # noqa: E501
    charges: Optional[List[RampChargeResponse]] = Field(default=None, description="Container for the rate plan charges that are considered as part of the ramp deal.")
    description: Optional[StrictStr] = Field(default=None, description="The short description of the ramp.")
    id: Optional[StrictStr] = Field(default=None, description="The ID of the ramp.")
    intervals: Optional[List[RampIntervalResponse]] = Field(default=None, description="Container for the intervals that the ramp is split into in its timeline.")
    name: Optional[StrictStr] = Field(default=None, description="The name of the ramp.")
    number: Optional[StrictStr] = Field(default=None, description="The number of the ramp. It is automaticcally generated by the billing system.")
    subscription_number: Optional[StrictStr] = Field(default=None, description="The number of the subscription that is considered as part of the ramp deal.", alias="subscriptionNumber")
    __properties: ClassVar[List[str]] = ["charges", "description", "id", "intervals", "name", "number", "subscriptionNumber"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RampResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in charges (list)
        _items = []
        if self.charges:
            for _item in self.charges:
                if _item:
                    _items.append(_item.to_dict())
            _dict['charges'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in intervals (list)
        _items = []
        if self.intervals:
            for _item in self.intervals:
                if _item:
                    _items.append(_item.to_dict())
            _dict['intervals'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RampResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "charges": [RampChargeResponse.from_dict(_item) for _item in obj["charges"]] if obj.get("charges") is not None else None,
            "description": obj.get("description"),
            "id": obj.get("id"),
            "intervals": [RampIntervalResponse.from_dict(_item) for _item in obj["intervals"]] if obj.get("intervals") is not None else None,
            "name": obj.get("name"),
            "number": obj.get("number"),
            "subscriptionNumber": obj.get("subscriptionNumber")
        })
        return _obj


