# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class ReversePaymentRequest(BaseModel):
    """
    ReversePaymentRequest
    """ # noqa: E501
    amount: Union[StrictFloat, StrictInt] = Field(description="The amount that needs to be reversed (chargeback). It cannot be greater than the total Payment amount.  ")
    gateway_reconciliation_reason: Optional[StrictStr] = Field(default=None, description="The reason of gateway reconciliation. ", alias="gatewayReconciliationReason")
    gateway_reconciliation_status: Optional[StrictStr] = Field(default=None, description="The status of gateway reconciliation. ", alias="gatewayReconciliationStatus")
    gateway_response: Optional[StrictStr] = Field(default=None, description="The transaction response returned by the gateway for this transaction. If the transaction was declined, this reason is provided in the message. ", alias="gatewayResponse")
    gateway_response_code: Optional[StrictStr] = Field(default=None, description="Response message Code returned by the gateway about the transaction status. ", alias="gatewayResponseCode")
    payout_id: Optional[StrictStr] = Field(default=None, description="The payout ID from the gateway side. ", alias="payoutId")
    reference_id: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="Unique Id generated by the gateway for each transaction. Use this ID to find the respective Zuora Payment ID.  ", alias="referenceId")
    second_reference_id: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="The second reference Id. Some gateways use two unique transaction IDs. ", alias="secondReferenceId")
    settled_on: Optional[StrictStr] = Field(default=None, description="The date and time of the transaction settlement. The format is `yyyy-mm-dd hh:mm:ss`. ", alias="settledOn")
    __properties: ClassVar[List[str]] = ["amount", "gatewayReconciliationReason", "gatewayReconciliationStatus", "gatewayResponse", "gatewayResponseCode", "payoutId", "referenceId", "secondReferenceId", "settledOn"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReversePaymentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReversePaymentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "amount": obj.get("amount"),
            "gatewayReconciliationReason": obj.get("gatewayReconciliationReason"),
            "gatewayReconciliationStatus": obj.get("gatewayReconciliationStatus"),
            "gatewayResponse": obj.get("gatewayResponse"),
            "gatewayResponseCode": obj.get("gatewayResponseCode"),
            "payoutId": obj.get("payoutId"),
            "referenceId": obj.get("referenceId"),
            "secondReferenceId": obj.get("secondReferenceId"),
            "settledOn": obj.get("settledOn")
        })
        return _obj


