# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class RevproAccountingCodes(BaseModel):
    """
    RevproAccountingCodes
    """ # noqa: E501
    adjustment_liability_account: Annotated[str, Field(strict=True, max_length=100)] = Field(description="The name of the account where the Account Type is \"Adjustment Liability\".", alias="adjustmentLiabilityAccount")
    adjustment_revenue_account: Annotated[str, Field(strict=True, max_length=100)] = Field(description="The name of the account where the Account Type is \"Adjustment Revenue\".", alias="adjustmentRevenueAccount")
    contract_asset_account: Annotated[str, Field(strict=True, max_length=100)] = Field(description="The name of the account where the Account Type is \"Contract Asset\".", alias="contractAssetAccount")
    contract_liability_account: Annotated[str, Field(strict=True, max_length=100)] = Field(description="The name of the account where the Account Type is \"Contract Liability\".", alias="contractLiabilityAccount")
    product_rate_plan_charge_id: StrictStr = Field(description="The ID of your product rate plan charge.", alias="productRatePlanChargeId")
    recognized_revenue_account: Annotated[str, Field(strict=True, max_length=100)] = Field(description="The name of the account where the Account Type is \"Recognized Revenue\".", alias="recognizedRevenueAccount")
    unbilled_receivables_account: Annotated[str, Field(strict=True, max_length=100)] = Field(description="The name of the account where the Account Type is \"Unbilled Receivables\".", alias="unbilledReceivablesAccount")
    __properties: ClassVar[List[str]] = ["adjustmentLiabilityAccount", "adjustmentRevenueAccount", "contractAssetAccount", "contractLiabilityAccount", "productRatePlanChargeId", "recognizedRevenueAccount", "unbilledReceivablesAccount"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RevproAccountingCodes from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RevproAccountingCodes from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "adjustmentLiabilityAccount": obj.get("adjustmentLiabilityAccount"),
            "adjustmentRevenueAccount": obj.get("adjustmentRevenueAccount"),
            "contractAssetAccount": obj.get("contractAssetAccount"),
            "contractLiabilityAccount": obj.get("contractLiabilityAccount"),
            "productRatePlanChargeId": obj.get("productRatePlanChargeId"),
            "recognizedRevenueAccount": obj.get("recognizedRevenueAccount"),
            "unbilledReceivablesAccount": obj.get("unbilledReceivablesAccount")
        })
        return _obj


