# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.setting_item_http_request_parameter import SettingItemHttpRequestParameter
from typing import Optional, Set
from typing_extensions import Self

class SettingItemHttpOperation(BaseModel):
    """
    SettingItemHttpOperation
    """ # noqa: E501
    method: Optional[StrictStr] = None
    parameters: Optional[List[SettingItemHttpRequestParameter]] = Field(default=None, description="An array of paramters required by this operation.")
    request_type: Optional[Dict[str, Any]] = Field(default=None, description="JSON Schema for the request body of this operation.", alias="requestType")
    response_type: Optional[Dict[str, Any]] = Field(default=None, description="JSON Schema for the response body of this operation.", alias="responseType")
    url: Optional[StrictStr] = Field(default=None, description="The endpoint url of the operation method. For example, `/settings/billing-rules`.")
    __properties: ClassVar[List[str]] = ["method", "parameters", "requestType", "responseType", "url"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SettingItemHttpOperation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in parameters (list)
        _items = []
        if self.parameters:
            for _item in self.parameters:
                if _item:
                    _items.append(_item.to_dict())
            _dict['parameters'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SettingItemHttpOperation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "method": obj.get("method"),
            "parameters": [SettingItemHttpRequestParameter.from_dict(_item) for _item in obj["parameters"]] if obj.get("parameters") is not None else None,
            "requestType": obj.get("requestType"),
            "responseType": obj.get("responseType"),
            "url": obj.get("url")
        })
        return _obj


