# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.account_data import AccountData
from zuora_sdk.models.options import Options
from zuora_sdk.models.payment_data import PaymentData
from zuora_sdk.models.subscription_data import SubscriptionData
from typing import Optional, Set
from typing_extensions import Self

class SignUpRequest(BaseModel):
    """
    SignUpRequest
    """ # noqa: E501
    account_data: Optional[AccountData] = Field(default=None, alias="accountData")
    account_identifier_field: Optional[StrictStr] = Field(default=None, description="Specify the name of the field that holds external account id", alias="accountIdentifierField")
    custom_fields: Optional[Dict[str, Dict[str, Any]]] = Field(default=None, description="Container for custom fields. ", alias="customFields")
    options: Optional[Options] = None
    payment_data: Optional[PaymentData] = Field(default=None, alias="paymentData")
    subscription_data: Optional[SubscriptionData] = Field(default=None, alias="subscriptionData")
    __properties: ClassVar[List[str]] = ["accountData", "accountIdentifierField", "customFields", "options", "paymentData", "subscriptionData"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SignUpRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of account_data
        if self.account_data:
            _dict['accountData'] = self.account_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of options
        if self.options:
            _dict['options'] = self.options.to_dict()
        # override the default output from pydantic by calling `to_dict()` of payment_data
        if self.payment_data:
            _dict['paymentData'] = self.payment_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of subscription_data
        if self.subscription_data:
            _dict['subscriptionData'] = self.subscription_data.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SignUpRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountData": AccountData.from_dict(obj["accountData"]) if obj.get("accountData") is not None else None,
            "accountIdentifierField": obj.get("accountIdentifierField"),
            "customFields": obj.get("customFields"),
            "options": Options.from_dict(obj["options"]) if obj.get("options") is not None else None,
            "paymentData": PaymentData.from_dict(obj["paymentData"]) if obj.get("paymentData") is not None else None,
            "subscriptionData": SubscriptionData.from_dict(obj["subscriptionData"]) if obj.get("subscriptionData") is not None else None
        })
        return _obj


