# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.sign_up_response_reasons import SignUpResponseReasons
from typing import Optional, Set
from typing_extensions import Self

class SignUpResponse(BaseModel):
    """
    SignUpResponse
    """ # noqa: E501
    account_id: Optional[StrictStr] = Field(default=None, description="The account id for the order.", alias="accountId")
    account_number: Optional[StrictStr] = Field(default=None, description="The account number for the order.", alias="accountNumber")
    credit_memo_id: Optional[StrictStr] = Field(default=None, description="An array of the credit memo id generated in this order request. The credit memo is only available if you have the Invoice Settlement feature enabled.", alias="creditMemoId")
    credit_memo_number: Optional[StrictStr] = Field(default=None, description="An array of the credit memo numbers generated in this order request. The credit memo is only available if you have the Invoice Settlement feature enabled.", alias="creditMemoNumber")
    invoice_id: Optional[StrictStr] = Field(default=None, description="The invoice id generated in this order request", alias="invoiceId")
    invoice_number: Optional[StrictStr] = Field(default=None, description="The invoice number generated in this order request", alias="invoiceNumber")
    order_number: Optional[StrictStr] = Field(default=None, description="The order number of the order created.", alias="orderNumber")
    paid_amount: Optional[StrictStr] = Field(default=None, description="The total amount collected in this order request.", alias="paidAmount")
    payment_id: Optional[StrictStr] = Field(default=None, description="The payment id that is collected in this order request.", alias="paymentId")
    payment_number: Optional[StrictStr] = Field(default=None, description="The payment number that is collected in this order request.", alias="paymentNumber")
    process_id: Optional[StrictStr] = Field(default=None, description="The Id of the process that handles the operation. ", alias="processId")
    reasons: Optional[List[SignUpResponseReasons]] = None
    status: Optional[StrictStr] = None
    subscription_id: Optional[StrictStr] = Field(default=None, description="The subscription id of the order.", alias="subscriptionId")
    subscription_number: Optional[StrictStr] = Field(default=None, description="The subscription number of the order.", alias="subscriptionNumber")
    success: Optional[StrictBool] = Field(default=None, description="Indicates whether the call succeeded. ")
    __properties: ClassVar[List[str]] = ["accountId", "accountNumber", "creditMemoId", "creditMemoNumber", "invoiceId", "invoiceNumber", "orderNumber", "paidAmount", "paymentId", "paymentNumber", "processId", "reasons", "status", "subscriptionId", "subscriptionNumber", "success"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SignUpResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in reasons (list)
        _items = []
        if self.reasons:
            for _item in self.reasons:
                if _item:
                    _items.append(_item.to_dict())
            _dict['reasons'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SignUpResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountId": obj.get("accountId"),
            "accountNumber": obj.get("accountNumber"),
            "creditMemoId": obj.get("creditMemoId"),
            "creditMemoNumber": obj.get("creditMemoNumber"),
            "invoiceId": obj.get("invoiceId"),
            "invoiceNumber": obj.get("invoiceNumber"),
            "orderNumber": obj.get("orderNumber"),
            "paidAmount": obj.get("paidAmount"),
            "paymentId": obj.get("paymentId"),
            "paymentNumber": obj.get("paymentNumber"),
            "processId": obj.get("processId"),
            "reasons": [SignUpResponseReasons.from_dict(_item) for _item in obj["reasons"]] if obj.get("reasons") is not None else None,
            "status": obj.get("status"),
            "subscriptionId": obj.get("subscriptionId"),
            "subscriptionNumber": obj.get("subscriptionNumber"),
            "success": obj.get("success")
        })
        return _obj


