# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class SignUpTaxInfo(BaseModel):
    """
    Information about the tax exempt status of a customer account. 
    """ # noqa: E501
    vatid: Optional[Annotated[str, Field(strict=True, max_length=25)]] = Field(default=None, description="EU Value Added Tax ID.  **Note:** This feature is in Limited Availability. If you wish to have access to the feature, submit a request at [Zuora Global Support](https://support.zuora.com). ", alias="VATId")
    company_code: Optional[Annotated[str, Field(strict=True, max_length=50)]] = Field(default=None, description="Unique code that identifies a company account in Avalara. Use this field to calculate taxes based on origin and sold-to addresses in Avalara.  **Note:** This feature is in Limited Availability. If you wish to have access to the feature, submit a request at [Zuora Global Support](https://support.zuora.com). ", alias="companyCode")
    exempt_certificate_id: Optional[Annotated[str, Field(strict=True, max_length=32)]] = Field(default=None, description="ID of the customer tax exemption certificate. Applicable if you use Zuora Tax or Connect tax engines. ", alias="exemptCertificateId")
    exempt_certificate_type: Optional[Annotated[str, Field(strict=True, max_length=32)]] = Field(default=None, description="Type of tax exemption certificate that the customer holds. Applicable if you use Zuora Tax or Connect tax engines. ", alias="exemptCertificateType")
    exempt_description: Optional[Annotated[str, Field(strict=True, max_length=500)]] = Field(default=None, description="Description of the tax exemption certificate that the customer holds. Applicable if you use Zuora Tax or Connect tax engines. ", alias="exemptDescription")
    exempt_effective_date: Optional[date] = Field(default=None, description="Date when the customer tax exemption starts, in YYYY-MM-DD format. Applicable if you use Zuora Tax or Connect tax engines. ", alias="exemptEffectiveDate")
    exempt_expiration_date: Optional[date] = Field(default=None, description="Date when the customer tax exemption expires, in YYYY-MM-DD format. Applicable if you use Zuora Tax or Connect tax engines. ", alias="exemptExpirationDate")
    exempt_issuing_jurisdiction: Optional[Annotated[str, Field(strict=True, max_length=32)]] = Field(default=None, description="Jurisdiction in which the customer tax exemption certificate was issued. ", alias="exemptIssuingJurisdiction")
    exempt_status: Optional[StrictStr] = Field(default=None, alias="exemptStatus")
    __properties: ClassVar[List[str]] = ["VATId", "companyCode", "exemptCertificateId", "exemptCertificateType", "exemptDescription", "exemptEffectiveDate", "exemptExpirationDate", "exemptIssuingJurisdiction", "exemptStatus"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SignUpTaxInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SignUpTaxInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "VATId": obj.get("VATId"),
            "companyCode": obj.get("companyCode"),
            "exemptCertificateId": obj.get("exemptCertificateId"),
            "exemptCertificateType": obj.get("exemptCertificateType"),
            "exemptDescription": obj.get("exemptDescription"),
            "exemptEffectiveDate": obj.get("exemptEffectiveDate"),
            "exemptExpirationDate": obj.get("exemptExpirationDate"),
            "exemptIssuingJurisdiction": obj.get("exemptIssuingJurisdiction"),
            "exemptStatus": obj.get("exemptStatus")
        })
        return _obj


