# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from zuora_sdk.models.rate_plan import RatePlan
from zuora_sdk.models.term_info import TermInfo
from typing import Optional, Set
from typing_extensions import Self

class SubscriptionData(BaseModel):
    """
    SubscriptionData
    """ # noqa: E501
    custom_fields: Optional[Dict[str, Dict[str, Any]]] = Field(default=None, description="Container for custom fields. ", alias="customFields")
    invoice_separately: Optional[StrictBool] = Field(default=None, description="Specifies whether the subscription appears on a separate invoice when Zuora generates invoices. ", alias="invoiceSeparately")
    notes: Optional[Annotated[str, Field(strict=True, max_length=500)]] = Field(default=None, description="Notes about the subscription. These notes are only visible to Zuora users. ")
    rate_plans: Optional[List[RatePlan]] = Field(default=None, alias="ratePlans")
    start_date: Optional[date] = Field(default=None, alias="startDate")
    subscription_number: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="Subscription number of the subscription to create, for example, A-S00000001.  If you do not set this field, Zuora will generate a subscription number. ", alias="subscriptionNumber")
    terms: Optional[TermInfo] = None
    __properties: ClassVar[List[str]] = ["customFields", "invoiceSeparately", "notes", "ratePlans", "startDate", "subscriptionNumber", "terms"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SubscriptionData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in rate_plans (list)
        _items = []
        if self.rate_plans:
            for _item in self.rate_plans:
                if _item:
                    _items.append(_item.to_dict())
            _dict['ratePlans'] = _items
        # override the default output from pydantic by calling `to_dict()` of terms
        if self.terms:
            _dict['terms'] = self.terms.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SubscriptionData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "customFields": obj.get("customFields"),
            "invoiceSeparately": obj.get("invoiceSeparately"),
            "notes": obj.get("notes"),
            "ratePlans": [RatePlan.from_dict(_item) for _item in obj["ratePlans"]] if obj.get("ratePlans") is not None else None,
            "startDate": obj.get("startDate"),
            "subscriptionNumber": obj.get("subscriptionNumber"),
            "terms": TermInfo.from_dict(obj["terms"]) if obj.get("terms") is not None else None
        })
        return _obj


