# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.setting_source_component_response import SettingSourceComponentResponse
from typing import Optional, Set
from typing_extensions import Self

class TemplateDetailResponse(BaseModel):
    """
    Contains all template details.
    """ # noqa: E501
    active: Optional[StrictBool] = Field(default=None, description="Whether or not the template is active.")
    content: Optional[SettingSourceComponentResponse] = None
    created_by: Optional[StrictStr] = Field(default=None, description="Information about the user who created it.", alias="createdBy")
    created_on: Optional[StrictStr] = Field(default=None, description="When it is created.", alias="createdOn")
    description: Optional[StrictStr] = Field(default=None, description="Template description which contains the information about the created template.")
    entity_name: Optional[StrictStr] = Field(default=None, description="Name of the Entity", alias="entityName")
    environment: Optional[StrictStr] = Field(default=None, description="Details of the environment in which the template was created.")
    errors: Optional[StrictStr] = Field(default=None, description="Error information.")
    id: Optional[StrictStr] = Field(default=None, description="Id of the template.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the template.")
    status: Optional[StrictStr] = Field(default=None, description="The status of the template creation, such as whether it is in progress, completed, or failed.")
    tenant_name: Optional[StrictStr] = Field(default=None, description="Tenant's name for whom the template is created.", alias="tenantName")
    __properties: ClassVar[List[str]] = ["active", "content", "createdBy", "createdOn", "description", "entityName", "environment", "errors", "id", "name", "status", "tenantName"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TemplateDetailResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of content
        if self.content:
            _dict['content'] = self.content.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TemplateDetailResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "active": obj.get("active"),
            "content": SettingSourceComponentResponse.from_dict(obj["content"]) if obj.get("content") is not None else None,
            "createdBy": obj.get("createdBy"),
            "createdOn": obj.get("createdOn"),
            "description": obj.get("description"),
            "entityName": obj.get("entityName"),
            "environment": obj.get("environment"),
            "errors": obj.get("errors"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "status": obj.get("status"),
            "tenantName": obj.get("tenantName")
        })
        return _obj


