# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class Tier(BaseModel):
    """
    Tier
    """ # noqa: E501
    ending_unit: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="End number of a range of units for the tier. ", alias="endingUnit")
    price: Union[StrictFloat, StrictInt] = Field(description="Price of the tier if the charge is a flat fee, or the price of each unit in the tier if the charge model is tiered pricing. ")
    price_format: Optional[StrictStr] = Field(default=None, description="Indicates if pricing is a flat fee or is per unit.  Values:  * `FlatFee` * `PerUnit` ", alias="priceFormat")
    starting_unit: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Starting number of a range of units for the tier. ", alias="startingUnit")
    tier: StrictInt = Field(description="Unique number that identifies the tier that the price applies to. ")
    __properties: ClassVar[List[str]] = ["endingUnit", "price", "priceFormat", "startingUnit", "tier"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Tier from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Tier from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "endingUnit": obj.get("endingUnit"),
            "price": obj.get("price"),
            "priceFormat": obj.get("priceFormat"),
            "startingUnit": obj.get("startingUnit"),
            "tier": obj.get("tier")
        })
        return _obj


