# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class TimeSlicedTcbNetMetrics(BaseModel):
    """
    TimeSlicedTcbNetMetrics
    """ # noqa: E501
    amount: Optional[Union[StrictFloat, StrictInt]] = None
    discount_charge_number: Optional[StrictStr] = Field(default=None, alias="discountChargeNumber")
    end_date: Optional[date] = Field(default=None, alias="endDate")
    generated_reason: Optional[StrictStr] = Field(default=None, alias="generatedReason")
    invoice_owner: Optional[StrictStr] = Field(default=None, description="The acount number of the billing account that is billed for the subscription.", alias="invoiceOwner")
    order_item_id: Optional[StrictStr] = Field(default=None, description="The ID of the order item referenced by the order metrics.  This field is only available to existing Orders customers who already have access to the field.  **Note:** The following Order Metrics have been deprecated. Any new customers who onboard on [Orders](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/AA_Overview_of_Orders) or [Orders Harmonization](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Orders_Harmonization/Orders_Harmonization) will not get these metrics. * The Order ELP and Order Item objects  * The \"Generated Reason\" and \"Order Item ID\" fields in the Order MRR, Order TCB, Order TCV, and Order Quantity objects  Existing Orders customers who have these metrics will continue to be supported. ", alias="orderItemId")
    start_date: Optional[date] = Field(default=None, alias="startDate")
    subscription_owner: Optional[StrictStr] = Field(default=None, description="The acount number of the billing account that owns the subscription.", alias="subscriptionOwner")
    tax: Optional[Union[StrictFloat, StrictInt]] = None
    term_number: Optional[StrictInt] = Field(default=None, alias="termNumber")
    type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["amount", "discountChargeNumber", "endDate", "generatedReason", "invoiceOwner", "orderItemId", "startDate", "subscriptionOwner", "tax", "termNumber", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TimeSlicedTcbNetMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TimeSlicedTcbNetMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "amount": obj.get("amount"),
            "discountChargeNumber": obj.get("discountChargeNumber"),
            "endDate": obj.get("endDate"),
            "generatedReason": obj.get("generatedReason"),
            "invoiceOwner": obj.get("invoiceOwner"),
            "orderItemId": obj.get("orderItemId"),
            "startDate": obj.get("startDate"),
            "subscriptionOwner": obj.get("subscriptionOwner"),
            "tax": obj.get("tax"),
            "termNumber": obj.get("termNumber"),
            "type": obj.get("type")
        })
        return _obj


