# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.unapply_payment_debit_memo_application import UnapplyPaymentDebitMemoApplication
from zuora_sdk.models.unapply_payment_invoice_application import UnapplyPaymentInvoiceApplication
from typing import Optional, Set
from typing_extensions import Self

class UnapplyPaymentRequest(BaseModel):
    """
    UnapplyPaymentRequest
    """ # noqa: E501
    debit_memos: Optional[List[UnapplyPaymentDebitMemoApplication]] = Field(default=None, description="Container for debit memos. The maximum number of debit memos is 1,000. ", alias="debitMemos")
    effective_date: Optional[StrictStr] = Field(default=None, description="The date when the payment is unapplied, in `yyyy-mm-dd` format. ", alias="effectiveDate")
    invoices: Optional[List[UnapplyPaymentInvoiceApplication]] = Field(default=None, description="Container for invoices. The maximum number of invoice is 1,000. ")
    __properties: ClassVar[List[str]] = ["debitMemos", "effectiveDate", "invoices"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UnapplyPaymentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in debit_memos (list)
        _items = []
        if self.debit_memos:
            for _item in self.debit_memos:
                if _item:
                    _items.append(_item.to_dict())
            _dict['debitMemos'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in invoices (list)
        _items = []
        if self.invoices:
            for _item in self.invoices:
                if _item:
                    _items.append(_item.to_dict())
            _dict['invoices'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UnapplyPaymentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "debitMemos": [UnapplyPaymentDebitMemoApplication.from_dict(_item) for _item in obj["debitMemos"]] if obj.get("debitMemos") is not None else None,
            "effectiveDate": obj.get("effectiveDate"),
            "invoices": [UnapplyPaymentInvoiceApplication.from_dict(_item) for _item in obj["invoices"]] if obj.get("invoices") is not None else None
        })
        return _obj


