# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.accounting_code_type import AccountingCodeType
from typing import Optional, Set
from typing_extensions import Self

class UpdateAccountingCodeRequest(BaseModel):
    """
    UpdateAccountingCodeRequest
    """ # noqa: E501
    gl_account_name: Optional[StrictStr] = Field(default=None, description="Name of the account in your general ledger.  Field only available if you have Zuora Finance enabled. Maximum of 255 characters. ", alias="glAccountName")
    gl_account_number: Optional[StrictStr] = Field(default=None, description="Account number in your general ledger.  Field only available if you have Zuora Finance enabled. Maximum of 255 characters. ", alias="glAccountNumber")
    name: Optional[StrictStr] = Field(default=None, description="Name of the accounting code.  Accounting code name must be unique. Maximum of 100 characters. ")
    notes: Optional[StrictStr] = Field(default=None, description="Maximum of 2,000 characters. ")
    type: Optional[AccountingCodeType] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["glAccountName", "glAccountNumber", "name", "notes", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateAccountingCodeRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateAccountingCodeRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "glAccountName": obj.get("glAccountName"),
            "glAccountNumber": obj.get("glAccountNumber"),
            "name": obj.get("name"),
            "notes": obj.get("notes"),
            "type": obj.get("type")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


