# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UpdateAccountingPeriodRequest(BaseModel):
    """
    UpdateAccountingPeriodRequest
    """ # noqa: E501
    end_date: Optional[date] = Field(default=None, description="The end date of the accounting period in yyyy-mm-dd format, for example, \"2016-02-19\". ", alias="endDate")
    fiscal_year: Optional[StrictStr] = Field(default=None, description="Fiscal year of the accounting period in yyyy format, for example, \"2016\". ", alias="fiscalYear")
    fiscal_quarter: Optional[StrictInt] = None
    name: Optional[StrictStr] = Field(default=None, description="Name of the accounting period.  Accounting period name must be unique. Maximum of 100 characters. ")
    notes: Optional[StrictStr] = Field(default=None, description="Notes about the accounting period.  Maximum of 255 characters. ")
    start_date: Optional[date] = Field(default=None, description="The start date of the accounting period in yyyy-mm-dd format, for example, \"2016-02-19\". ", alias="startDate")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["endDate", "fiscalYear", "fiscal_quarter", "name", "notes", "startDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateAccountingPeriodRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateAccountingPeriodRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "endDate": obj.get("endDate"),
            "fiscalYear": obj.get("fiscalYear"),
            "fiscal_quarter": obj.get("fiscal_quarter"),
            "name": obj.get("name"),
            "notes": obj.get("notes"),
            "startDate": obj.get("startDate")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


