# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.create_or_update_catalog_group_product_rate_plan import CreateOrUpdateCatalogGroupProductRatePlan
from zuora_sdk.models.remove_catalog_group_product_rate_plan import RemoveCatalogGroupProductRatePlan
from typing import Optional, Set
from typing_extensions import Self

class UpdateCatalogGroupRequest(BaseModel):
    """
    UpdateCatalogGroupRequest
    """ # noqa: E501
    add: Optional[List[CreateOrUpdateCatalogGroupProductRatePlan]] = Field(default=None, description="The list of product rate plans to be added to the catalog group. ")
    description: Optional[StrictStr] = Field(default=None, description="The description of the catalog group. ")
    name: Optional[StrictStr] = Field(default=None, description="The unique name of the catalog group. ")
    remove: Optional[List[List[RemoveCatalogGroupProductRatePlan]]] = Field(default=None, description="The list of product rate plans to be removed from the catalog group. ")
    __properties: ClassVar[List[str]] = ["add", "description", "name", "remove"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateCatalogGroupRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in add (list)
        _items = []
        if self.add:
            for _item in self.add:
                if _item:
                    _items.append(_item.to_dict())
            _dict['add'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in remove (list of list)
        _items = []
        if self.remove:
            for _item in self.remove:
                if _item:
                    _items.append(
                         [_inner_item.to_dict() for _inner_item in _item if _inner_item is not None]
                    )
            _dict['remove'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateCatalogGroupRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "add": [CreateOrUpdateCatalogGroupProductRatePlan.from_dict(_item) for _item in obj["add"]] if obj.get("add") is not None else None,
            "description": obj.get("description"),
            "name": obj.get("name"),
            "remove": [
                    [RemoveCatalogGroupProductRatePlan.from_dict(_inner_item) for _inner_item in _item]
                    for _item in obj["remove"]
                ] if obj.get("remove") is not None else None
        })
        return _obj


