# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from decimal import Decimal
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class UpdateInvoiceScheduleItem(BaseModel):
    """
    UpdateInvoiceScheduleItem
    """ # noqa: E501
    amount: Optional[Decimal] = Field(default=None, description="The amount of the invoice to be generated during the processing of the invoice schedule item. You can only specify one of the `amount` and `percentage` fields. ")
    id: Optional[StrictStr] = Field(default=None, description="The unique ID of the invoice schedule item to be updated.   If this field is not provided, a new invoice schedule item is added to the invoice schedule. ")
    name: Optional[Annotated[str, Field(strict=True, max_length=100)]] = Field(default=None, description="The name of the invoice schedule item. ")
    percentage: Optional[Annotated[Decimal, Field(strict=True, ge=100)]] = Field(default=None, description="The percentage of the total amount to be generated during the processing of the invoice schedule item. The field value must be greater than 0. You can only specify one of the `amount` and `percentage` fields.")
    run_date: Optional[date] = Field(default=None, description="The date in the tenant’s time zone when the invoice schedule item is planned to be processed to generate an invoice. ", alias="runDate")
    target_date_for_additional_subscriptions: Optional[date] = Field(default=None, description="The date in the tenant's time zone used by the invoice schedule to determine which fixed-period regular charges to be billed together with the invoice schedule item.   The regular charges must come from the subscriptions specified in the `additionalSubscriptionsToBill` field. ", alias="targetDateForAdditionalSubscriptions")
    __properties: ClassVar[List[str]] = ["amount", "id", "name", "percentage", "runDate", "targetDateForAdditionalSubscriptions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateInvoiceScheduleItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateInvoiceScheduleItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "amount": obj.get("amount"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "percentage": obj.get("percentage"),
            "runDate": obj.get("runDate"),
            "targetDateForAdditionalSubscriptions": obj.get("targetDateForAdditionalSubscriptions")
        })
        return _obj


