# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.update_order_action_charge_trigger_date import UpdateOrderActionChargeTriggerDate
from zuora_sdk.models.update_order_action_trigger_date import UpdateOrderActionTriggerDate
from typing import Optional, Set
from typing_extensions import Self

class UpdateOrderActionTriggerDates(BaseModel):
    """
    UpdateOrderActionTriggerDates
    """ # noqa: E501
    charges: Optional[List[UpdateOrderActionChargeTriggerDate]] = None
    sequence: StrictInt = Field(description="Identifies which order action will have its triggering dates updated.  ")
    trigger_dates: Optional[List[UpdateOrderActionTriggerDate]] = Field(default=None, description="Container for the service activation and customer acceptance dates of the order action.", alias="triggerDates")
    __properties: ClassVar[List[str]] = ["charges", "sequence", "triggerDates"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateOrderActionTriggerDates from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in charges (list)
        _items = []
        if self.charges:
            for _item in self.charges:
                if _item:
                    _items.append(_item.to_dict())
            _dict['charges'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in trigger_dates (list)
        _items = []
        if self.trigger_dates:
            for _item in self.trigger_dates:
                if _item:
                    _items.append(_item.to_dict())
            _dict['triggerDates'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateOrderActionTriggerDates from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "charges": [UpdateOrderActionChargeTriggerDate.from_dict(_item) for _item in obj["charges"]] if obj.get("charges") is not None else None,
            "sequence": obj.get("sequence"),
            "triggerDates": [UpdateOrderActionTriggerDate.from_dict(_item) for _item in obj["triggerDates"]] if obj.get("triggerDates") is not None else None
        })
        return _obj


