# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2023-10-24
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class UpdateTask(BaseModel):
    """
    A task. 
    """ # noqa: E501
    action_type: Optional[StrictStr] = Field(default=None, description="The type of task. ")
    call_type: Optional[StrictStr] = Field(default=None, description="The type of the API used. ")
    concurrent_limit: Optional[Annotated[int, Field(le=9999999, strict=True, ge=1)]] = Field(default=None, description="The maximum number of this task that can run concurrently. ")
    id: StrictInt = Field(description="The unique ID of the task. ")
    name: Optional[StrictStr] = Field(default=None, description="The name of the task. ")
    object: Optional[StrictStr] = Field(default=None, description="The selected object for the task. ")
    object_id: Optional[StrictStr] = Field(default=None, description="The ID of the selected object of the task. ")
    status: Optional[StrictStr] = None
    tags: Optional[List[StrictStr]] = Field(default=None, description="The array of filter tags. ")
    workflow_id: Optional[StrictInt] = Field(default=None, description="The ID of the workflow the task belongs to. ")
    __properties: ClassVar[List[str]] = ["action_type", "call_type", "concurrent_limit", "id", "name", "object", "object_id", "status", "tags", "workflow_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateTask from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateTask from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "action_type": obj.get("action_type"),
            "call_type": obj.get("call_type"),
            "concurrent_limit": obj.get("concurrent_limit"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "object": obj.get("object"),
            "object_id": obj.get("object_id"),
            "status": obj.get("status"),
            "tags": obj.get("tags"),
            "workflow_id": obj.get("workflow_id")
        })
        return _obj


